/* WindowSwitcher.c generated by valac 0.44.11, the Vala compiler
 * generated from WindowSwitcher.vala, do not modify */

/**/
/*  Copyright (C) 2012 Tom Beckmann, Rico Tzschichholz*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <clutter/clutter.h>
#include <glib-object.h>
#include "gala.h"
#include <glib.h>
#include <meta/meta-window-actor.h>
#include <plank.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <meta/meta-plugin.h>
#include <meta/screen.h>
#include <meta/boxes.h>
#include <gtk/gtk.h>
#include <cairo.h>
#include <meta/display.h>
#include <gdk/gdk.h>
#include <meta/window.h>
#include <meta/keybindings.h>
#include <meta/workspace.h>
#include <stdlib.h>
#include <string.h>
#include <meta/compositor-mutter.h>
#include <granite.h>

#define GALA_TYPE_WINDOW_SWITCHER (gala_window_switcher_get_type ())
#define GALA_WINDOW_SWITCHER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcher))
#define GALA_WINDOW_SWITCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcherClass))
#define GALA_IS_WINDOW_SWITCHER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_SWITCHER))
#define GALA_IS_WINDOW_SWITCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WINDOW_SWITCHER))
#define GALA_WINDOW_SWITCHER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcherClass))

typedef struct _GalaWindowSwitcher GalaWindowSwitcher;
typedef struct _GalaWindowSwitcherClass GalaWindowSwitcherClass;
typedef struct _GalaWindowSwitcherPrivate GalaWindowSwitcherPrivate;
enum  {
	GALA_WINDOW_SWITCHER_0_PROPERTY,
	GALA_WINDOW_SWITCHER_WM_PROPERTY,
	GALA_WINDOW_SWITCHER_NUM_PROPERTIES
};
static GParamSpec* gala_window_switcher_properties[GALA_WINDOW_SWITCHER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define GALA_TYPE_SAFE_WINDOW_CLONE (gala_safe_window_clone_get_type ())
#define GALA_SAFE_WINDOW_CLONE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_SAFE_WINDOW_CLONE, GalaSafeWindowClone))
#define GALA_SAFE_WINDOW_CLONE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_SAFE_WINDOW_CLONE, GalaSafeWindowCloneClass))
#define GALA_IS_SAFE_WINDOW_CLONE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_SAFE_WINDOW_CLONE))
#define GALA_IS_SAFE_WINDOW_CLONE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_SAFE_WINDOW_CLONE))
#define GALA_SAFE_WINDOW_CLONE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_SAFE_WINDOW_CLONE, GalaSafeWindowCloneClass))

typedef struct _GalaSafeWindowClone GalaSafeWindowClone;
typedef struct _GalaSafeWindowCloneClass GalaSafeWindowCloneClass;

#define GALA_TYPE_BEHAVIOR_SETTINGS (gala_behavior_settings_get_type ())
#define GALA_BEHAVIOR_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_BEHAVIOR_SETTINGS, GalaBehaviorSettings))
#define GALA_BEHAVIOR_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_BEHAVIOR_SETTINGS, GalaBehaviorSettingsClass))
#define GALA_IS_BEHAVIOR_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_BEHAVIOR_SETTINGS))
#define GALA_IS_BEHAVIOR_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_BEHAVIOR_SETTINGS))
#define GALA_BEHAVIOR_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_BEHAVIOR_SETTINGS, GalaBehaviorSettingsClass))

typedef struct _GalaBehaviorSettings GalaBehaviorSettings;
typedef struct _GalaBehaviorSettingsClass GalaBehaviorSettingsClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block45Data Block45Data;

struct _GalaWindowSwitcher {
	ClutterActor parent_instance;
	GalaWindowSwitcherPrivate * priv;
};

struct _GalaWindowSwitcherClass {
	ClutterActorClass parent_class;
};

struct _GalaWindowSwitcherPrivate {
	GalaWindowManager* _wm;
	GalaWindowIcon* current_window;
	ClutterActor* window_clones;
	GList* clone_sort_order;
	MetaWindowActor* dock_window;
	ClutterActor* dock;
	PlankSurface* dock_surface;
	PlankDockTheme* dock_theme;
	PlankDockPreferences* dock_settings;
	gfloat dock_y_offset;
	gfloat dock_height_offset;
	gint ui_scale_factor;
	GFileMonitor* monitor;
	ClutterActor* background;
	guint modifier_mask;
	gint64 last_switch;
	gboolean closing;
	GalaModalProxy* modal_proxy;
	gfloat dock_width;
	gint n_dock_items;
};

struct _Block45Data {
	int _ref_count_;
	GalaWindowSwitcher* self;
	ClutterCanvas* dock_canvas;
};

static gint GalaWindowSwitcher_private_offset;
static gpointer gala_window_switcher_parent_class = NULL;

GType gala_window_switcher_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWindowSwitcher, g_object_unref)
GalaWindowManager* gala_window_switcher_get_wm (GalaWindowSwitcher* self);
static void gala_window_switcher_update_actors (GalaWindowSwitcher* self);
static void _gala_window_switcher_update_actors_meta_screen_monitors_changed (MetaScreen* _sender,
                                                                       gpointer self);
#define GALA_WINDOW_SWITCHER_MIN_DELTA 100
#define GALA_WINDOW_SWITCHER_BACKGROUND_OPACITY 155.0f
#define GALA_WINDOW_SWITCHER_DIM_WINDOW_BRIGHTNESS ((-GALA_WINDOW_SWITCHER_BACKGROUND_OPACITY) / 255.0f)
GalaWindowSwitcher* gala_window_switcher_new (GalaWindowManager* wm);
GalaWindowSwitcher* gala_window_switcher_construct (GType object_type,
                                                    GalaWindowManager* wm);
static void gala_window_switcher_load_dock_theme (GalaWindowSwitcher* self);
static void gala_window_switcher_update_dock (GalaWindowSwitcher* self);
static void _gala_window_switcher_update_dock_g_object_notify (GObject* _sender,
                                                        GParamSpec* pspec,
                                                        gpointer self);
gint gala_internal_utils_get_ui_scaling_factor (void);
static void gala_window_switcher_update_background (GalaWindowSwitcher* self);
static gboolean gala_window_switcher_draw_dock_background (GalaWindowSwitcher* self,
                                                    cairo_t* cr);
static void gala_window_switcher_place_dock (GalaWindowSwitcher* self);
static void gala_window_switcher_animate_dock_width (GalaWindowSwitcher* self);
static void gala_window_switcher_show_background (GalaWindowSwitcher* self);
static void gala_window_switcher_hide_background (GalaWindowSwitcher* self);
static gboolean gala_window_switcher_clicked_icon (GalaWindowSwitcher* self,
                                            ClutterButtonEvent* event);
static void gala_window_switcher_dim_windows (GalaWindowSwitcher* self);
static gboolean ___lambda45_ (GalaWindowSwitcher* self);
static void gala_window_switcher_close (GalaWindowSwitcher* self,
                                 guint time);
static gboolean ____lambda45__gsource_func (gpointer self);
static void gala_window_switcher_window_removed (GalaWindowSwitcher* self,
                                          ClutterActor* actor);
static void gala_window_switcher_icon_removed (GalaWindowSwitcher* self,
                                        ClutterActor* actor);
static gboolean gala_window_switcher_real_key_release_event (ClutterActor* base,
                                                      ClutterKeyEvent* event);
static GdkModifierType gala_window_switcher_get_current_modifiers (GalaWindowSwitcher* self);
static void gala_window_switcher_real_key_focus_out (ClutterActor* base);
void gala_window_switcher_handle_switch_windows (MetaDisplay* display,
                                                 MetaScreen* screen,
                                                 MetaWindow* window,
                                                 ClutterKeyEvent* event,
                                                 MetaKeyBinding* binding,
                                                 GalaWindowSwitcher* self);
static void gala_window_switcher_close_cleanup (GalaWindowSwitcher* self);
static GalaWindowIcon* gala_window_switcher_next_window (GalaWindowSwitcher* self,
                                                  MetaWorkspace* workspace,
                                                  gboolean backward);
static gboolean gala_window_switcher_collect_windows (GalaWindowSwitcher* self,
                                               MetaWorkspace* workspace);
static void gala_window_switcher_set_primary_modifier (GalaWindowSwitcher* self,
                                                guint mask);
static gboolean __lambda47_ (GalaWindowSwitcher* self,
                      MetaKeyBinding* binding);
static gboolean ___lambda47__gala_keybinding_filter (MetaKeyBinding* binding,
                                              gpointer self);
GType gala_safe_window_clone_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaSafeWindowClone, g_object_unref)
MetaWindow* gala_safe_window_clone_get_window (GalaSafeWindowClone* self);
static void ___lambda46_ (GalaWindowSwitcher* self);
static void ____lambda46__clutter_timeline_completed (ClutterTimeline* _sender,
                                               gpointer self);
static GalaWindowIcon* gala_window_switcher_add_window (GalaWindowSwitcher* self,
                                                 MetaWindow* window);
GalaSafeWindowClone* gala_safe_window_clone_new (MetaWindow* window,
                                                 gboolean destroy_on_unmanaged);
GalaSafeWindowClone* gala_safe_window_clone_construct (GType object_type,
                                                       MetaWindow* window,
                                                       gboolean destroy_on_unmanaged);
static gboolean _gala_window_switcher_clicked_icon_clutter_actor_button_release_event (ClutterActor* _sender,
                                                                                ClutterButtonEvent* event,
                                                                                gpointer self);
GType gala_behavior_settings_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaBehaviorSettings, g_object_unref)
GalaBehaviorSettings* gala_behavior_settings_get_default (void);
gchar** gala_behavior_settings_get_dock_names (GalaBehaviorSettings* self,
                                               gint* result_length1);
static gboolean _vala_string_array_contains (gchar* * stack,
                                      int stack_length,
                                      const gchar* needle);
static void gala_window_switcher_update_n_dock_items (GalaWindowSwitcher* self,
                                               GFile* folder,
                                               GFile* other_file,
                                               GFileMonitorEvent event);
static void gala_window_switcher_set_wm (GalaWindowSwitcher* self,
                                  GalaWindowManager* value);
static GObject * gala_window_switcher_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static Block45Data* block45_data_ref (Block45Data* _data45_);
static void block45_data_unref (void * _userdata_);
static void _gala_window_switcher_load_dock_theme_g_object_notify (GObject* _sender,
                                                            GParamSpec* pspec,
                                                            gpointer self);
static void _gala_window_switcher_update_n_dock_items_g_file_monitor_changed (GFileMonitor* _sender,
                                                                       GFile* file,
                                                                       GFile* other_file,
                                                                       GFileMonitorEvent event_type,
                                                                       gpointer self);
static gboolean _gala_window_switcher_draw_dock_background_clutter_canvas_draw (ClutterCanvas* _sender,
                                                                         cairo_t* cr,
                                                                         gint width,
                                                                         gint height,
                                                                         gpointer self);
static void _gala_window_switcher_icon_removed_clutter_container_actor_removed (ClutterContainer* _sender,
                                                                         ClutterActor* actor,
                                                                         gpointer self);
static void _gala_window_switcher___lambda48_ (Block45Data* _data45_);
static void __gala_window_switcher___lambda48__g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self);
static void _gala_window_switcher_window_removed_clutter_container_actor_removed (ClutterContainer* _sender,
                                                                           ClutterActor* actor,
                                                                           gpointer self);
static void gala_window_switcher_finalize (GObject * obj);
static void _vala_gala_window_switcher_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_gala_window_switcher_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);

static inline gpointer
gala_window_switcher_get_instance_private (GalaWindowSwitcher* self)
{
	return G_STRUCT_MEMBER_P (self, GalaWindowSwitcher_private_offset);
}

static void
_gala_window_switcher_update_actors_meta_screen_monitors_changed (MetaScreen* _sender,
                                                                  gpointer self)
{
	gala_window_switcher_update_actors ((GalaWindowSwitcher*) self);
}

GalaWindowSwitcher*
gala_window_switcher_construct (GType object_type,
                                GalaWindowManager* wm)
{
	GalaWindowSwitcher * self = NULL;
	g_return_val_if_fail (wm != NULL, NULL);
	self = (GalaWindowSwitcher*) g_object_new (object_type, "wm", wm, NULL);
	return self;
}

GalaWindowSwitcher*
gala_window_switcher_new (GalaWindowManager* wm)
{
	return gala_window_switcher_construct (GALA_TYPE_WINDOW_SWITCHER, wm);
}

static void
_gala_window_switcher_update_dock_g_object_notify (GObject* _sender,
                                                   GParamSpec* pspec,
                                                   gpointer self)
{
	gala_window_switcher_update_dock ((GalaWindowSwitcher*) self);
}

static void
gala_window_switcher_load_dock_theme (GalaWindowSwitcher* self)
{
	PlankDockTheme* _tmp0_;
	PlankDockPreferences* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	PlankDockTheme* _tmp6_;
	PlankDockTheme* _tmp7_;
	PlankDockTheme* _tmp8_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->dock_theme;
	if (_tmp0_ != NULL) {
		PlankDockTheme* _tmp1_;
		guint _tmp2_;
		_tmp1_ = self->priv->dock_theme;
		g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp2_, NULL, FALSE);
		g_signal_handlers_disconnect_matched ((GObject*) _tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _gala_window_switcher_update_dock_g_object_notify, self);
	}
	_tmp3_ = self->priv->dock_settings;
	_tmp4_ = plank_dock_preferences_get_Theme (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = plank_dock_theme_new (_tmp5_);
	_g_object_unref0 (self->priv->dock_theme);
	self->priv->dock_theme = _tmp6_;
	_tmp7_ = self->priv->dock_theme;
	plank_theme_load ((PlankTheme*) _tmp7_, "dock");
	_tmp8_ = self->priv->dock_theme;
	g_signal_connect_object ((GObject*) _tmp8_, "notify", (GCallback) _gala_window_switcher_update_dock_g_object_notify, self, 0);
	gala_window_switcher_update_dock (self);
}

/**
         * set the values which don't get set every time and need to be updated when the theme changes
         */
static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
gala_window_switcher_update_dock (GalaWindowSwitcher* self)
{
	MetaScreen* screen = NULL;
	GalaWindowManager* _tmp0_;
	MetaScreen* _tmp1_;
	MetaScreen* _tmp2_;
	MetaRectangle geometry = {0};
	MetaScreen* _tmp3_;
	MetaScreen* _tmp4_;
	MetaRectangle _tmp5_ = {0};
	ClutterBoxLayout* layout = NULL;
	ClutterActor* _tmp6_;
	ClutterLayoutManager* _tmp7_;
	ClutterLayoutManager* _tmp8_;
	ClutterBoxLayout* _tmp9_;
	GtkPositionType position = 0;
	PlankDockPreferences* _tmp10_;
	GtkPositionType _tmp11_;
	GtkPositionType _tmp12_;
	gint icon_size = 0;
	PlankDockPreferences* _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	gfloat scaled_icon_size = 0.0F;
	gboolean horizontal = FALSE;
	PlankDockPreferences* _tmp16_;
	gfloat top_padding = 0.0F;
	PlankDockTheme* _tmp17_;
	gdouble _tmp18_;
	gdouble _tmp19_;
	gfloat bottom_padding = 0.0F;
	PlankDockTheme* _tmp20_;
	gdouble _tmp21_;
	gdouble _tmp22_;
	gfloat item_padding = 0.0F;
	PlankDockTheme* _tmp23_;
	gdouble _tmp24_;
	gdouble _tmp25_;
	gint line_width = 0;
	PlankDockTheme* _tmp26_;
	gint _tmp27_;
	gint _tmp28_;
	gfloat top_offset = 0.0F;
	gint _tmp29_ = 0;
	PlankDockTheme* _tmp30_;
	gint _tmp31_;
	gint _tmp32_;
	gfloat bottom_offset = 0.0F;
	ClutterBoxLayout* _tmp33_;
	ClutterOrientation _tmp34_ = 0;
	ClutterBoxLayout* _tmp35_;
	gfloat _tmp36_ = 0.0F;
	gfloat height = 0.0F;
	GtkPositionType _tmp45_;
	g_return_if_fail (self != NULL);
	self->priv->ui_scale_factor = gala_internal_utils_get_ui_scaling_factor ();
	_tmp0_ = self->priv->_wm;
	_tmp1_ = meta_plugin_get_screen ((MetaPlugin*) _tmp0_);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	screen = _tmp2_;
	_tmp3_ = screen;
	_tmp4_ = screen;
	meta_screen_get_monitor_geometry (_tmp3_, meta_screen_get_primary_monitor (_tmp4_), &_tmp5_);
	geometry = _tmp5_;
	_tmp6_ = self->priv->dock;
	_tmp7_ = clutter_actor_get_layout_manager (_tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, clutter_box_layout_get_type (), ClutterBoxLayout));
	layout = _tmp9_;
	_tmp10_ = self->priv->dock_settings;
	_tmp11_ = plank_dock_preferences_get_Position (_tmp10_);
	_tmp12_ = _tmp11_;
	position = _tmp12_;
	_tmp13_ = self->priv->dock_settings;
	_tmp14_ = plank_dock_preferences_get_IconSize (_tmp13_);
	_tmp15_ = _tmp14_;
	icon_size = _tmp15_ * self->priv->ui_scale_factor;
	scaled_icon_size = icon_size / 10.0f;
	_tmp16_ = self->priv->dock_settings;
	horizontal = plank_dock_preferences_is_horizontal_dock (_tmp16_);
	_tmp17_ = self->priv->dock_theme;
	_tmp18_ = plank_dock_theme_get_TopPadding (_tmp17_);
	_tmp19_ = _tmp18_;
	top_padding = ((gfloat) _tmp19_) * scaled_icon_size;
	_tmp20_ = self->priv->dock_theme;
	_tmp21_ = plank_dock_theme_get_BottomPadding (_tmp20_);
	_tmp22_ = _tmp21_;
	bottom_padding = ((gfloat) _tmp22_) * scaled_icon_size;
	_tmp23_ = self->priv->dock_theme;
	_tmp24_ = plank_dock_theme_get_ItemPadding (_tmp23_);
	_tmp25_ = _tmp24_;
	item_padding = ((gfloat) _tmp25_) * scaled_icon_size;
	_tmp26_ = self->priv->dock_theme;
	_tmp27_ = plank_theme_get_LineWidth ((PlankTheme*) _tmp26_);
	_tmp28_ = _tmp27_;
	line_width = _tmp28_ * self->priv->ui_scale_factor;
	top_offset = (2 * line_width) + top_padding;
	_tmp30_ = self->priv->dock_theme;
	_tmp31_ = plank_theme_get_BottomRoundness ((PlankTheme*) _tmp30_);
	_tmp32_ = _tmp31_;
	if (_tmp32_ > 0) {
		_tmp29_ = 2 * line_width;
	} else {
		_tmp29_ = 0;
	}
	bottom_offset = _tmp29_ + bottom_padding;
	_tmp33_ = layout;
	clutter_box_layout_set_spacing (_tmp33_, (guint) item_padding);
	if (horizontal) {
		_tmp34_ = CLUTTER_ORIENTATION_HORIZONTAL;
	} else {
		_tmp34_ = CLUTTER_ORIENTATION_VERTICAL;
	}
	_tmp35_ = layout;
	clutter_box_layout_set_orientation (_tmp35_, _tmp34_);
	self->priv->dock_y_offset = -top_offset;
	self->priv->dock_height_offset = top_offset + bottom_offset;
	if (top_offset > ((gfloat) 0)) {
		_tmp36_ = top_offset;
	} else {
		_tmp36_ = (gfloat) 0;
	}
	height = (icon_size + _tmp36_) + bottom_offset;
	if (horizontal) {
		ClutterActor* _tmp37_;
		ClutterActor* _tmp38_;
		MetaRectangle _tmp39_;
		MetaRectangle _tmp40_;
		_tmp37_ = self->priv->dock;
		clutter_actor_set_height (_tmp37_, height);
		_tmp38_ = self->priv->dock;
		_tmp39_ = geometry;
		_tmp40_ = geometry;
		clutter_actor_set_x (_tmp38_, ceilf (_tmp39_.x + (_tmp40_.width / 2.0f)));
	} else {
		ClutterActor* _tmp41_;
		ClutterActor* _tmp42_;
		MetaRectangle _tmp43_;
		MetaRectangle _tmp44_;
		_tmp41_ = self->priv->dock;
		clutter_actor_set_width (_tmp41_, height);
		_tmp42_ = self->priv->dock;
		_tmp43_ = geometry;
		_tmp44_ = geometry;
		clutter_actor_set_y (_tmp42_, ceilf (_tmp43_.y + (_tmp44_.height / 2.0f)));
	}
	_tmp45_ = position;
	switch (_tmp45_) {
		case GTK_POS_TOP:
		{
			ClutterActor* _tmp46_;
			MetaRectangle _tmp47_;
			_tmp46_ = self->priv->dock;
			_tmp47_ = geometry;
			clutter_actor_set_y (_tmp46_, ceilf ((gfloat) _tmp47_.y));
			break;
		}
		case GTK_POS_BOTTOM:
		{
			ClutterActor* _tmp48_;
			MetaRectangle _tmp49_;
			MetaRectangle _tmp50_;
			_tmp48_ = self->priv->dock;
			_tmp49_ = geometry;
			_tmp50_ = geometry;
			clutter_actor_set_y (_tmp48_, ceilf ((_tmp49_.y + _tmp50_.height) - height));
			break;
		}
		case GTK_POS_LEFT:
		{
			ClutterActor* _tmp51_;
			MetaRectangle _tmp52_;
			_tmp51_ = self->priv->dock;
			_tmp52_ = geometry;
			clutter_actor_set_x (_tmp51_, ceilf ((gfloat) _tmp52_.x));
			break;
		}
		case GTK_POS_RIGHT:
		{
			ClutterActor* _tmp53_;
			MetaRectangle _tmp54_;
			MetaRectangle _tmp55_;
			_tmp53_ = self->priv->dock;
			_tmp54_ = geometry;
			_tmp55_ = geometry;
			clutter_actor_set_x (_tmp53_, ceilf ((_tmp54_.x + _tmp55_.width) - height));
			break;
		}
		default:
		break;
	}
	_g_object_unref0 (self->priv->dock_surface);
	self->priv->dock_surface = NULL;
	_g_object_unref0 (layout);
	_g_object_unref0 (screen);
}

static void
gala_window_switcher_update_background (GalaWindowSwitcher* self)
{
	gint width = 0;
	gint height = 0;
	GalaWindowManager* _tmp0_;
	MetaScreen* _tmp1_;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	ClutterActor* _tmp4_;
	g_return_if_fail (self != NULL);
	width = 0;
	height = 0;
	_tmp0_ = self->priv->_wm;
	_tmp1_ = meta_plugin_get_screen ((MetaPlugin*) _tmp0_);
	meta_screen_get_size (_tmp1_, &_tmp2_, &_tmp3_);
	width = _tmp2_;
	height = _tmp3_;
	_tmp4_ = self->priv->background;
	clutter_actor_set_size (_tmp4_, (gfloat) width, (gfloat) height);
}

static void
gala_window_switcher_update_actors (GalaWindowSwitcher* self)
{
	g_return_if_fail (self != NULL);
	gala_window_switcher_update_dock (self);
	gala_window_switcher_update_background (self);
}

static gboolean
gala_window_switcher_draw_dock_background (GalaWindowSwitcher* self,
                                           cairo_t* cr)
{
	GtkPositionType position = 0;
	PlankDockPreferences* _tmp0_;
	GtkPositionType _tmp1_;
	GtkPositionType _tmp2_;
	gint width = 0;
	ClutterActor* _tmp3_;
	gfloat _tmp4_;
	gfloat _tmp5_;
	gint height = 0;
	ClutterActor* _tmp6_;
	gfloat _tmp7_;
	gfloat _tmp8_;
	GtkPositionType _tmp9_;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	PlankSurface* _tmp12_;
	gfloat x = 0.0F;
	gfloat y = 0.0F;
	GtkPositionType _tmp25_;
	PlankSurface* _tmp26_;
	cairo_surface_t* _tmp27_;
	cairo_surface_t* _tmp28_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (cr != NULL, FALSE);
	cairo_set_operator (cr, CAIRO_OPERATOR_CLEAR);
	cairo_paint (cr);
	cairo_set_operator (cr, CAIRO_OPERATOR_OVER);
	_tmp0_ = self->priv->dock_settings;
	_tmp1_ = plank_dock_preferences_get_Position (_tmp0_);
	_tmp2_ = _tmp1_;
	position = _tmp2_;
	_tmp3_ = self->priv->dock;
	_tmp4_ = clutter_actor_get_width (_tmp3_);
	_tmp5_ = _tmp4_;
	width = (gint) _tmp5_;
	_tmp6_ = self->priv->dock;
	_tmp7_ = clutter_actor_get_height (_tmp6_);
	_tmp8_ = _tmp7_;
	height = (gint) _tmp8_;
	_tmp9_ = position;
	switch (_tmp9_) {
		case GTK_POS_RIGHT:
		{
			width = width + ((gint) self->priv->dock_height_offset);
			break;
		}
		case GTK_POS_LEFT:
		{
			width = width - ((gint) self->priv->dock_y_offset);
			break;
		}
		case GTK_POS_TOP:
		{
			height = height - ((gint) self->priv->dock_y_offset);
			break;
		}
		case GTK_POS_BOTTOM:
		{
			height = height + ((gint) self->priv->dock_height_offset);
			break;
		}
		default:
		break;
	}
	_tmp12_ = self->priv->dock_surface;
	if (_tmp12_ == NULL) {
		_tmp11_ = TRUE;
	} else {
		PlankSurface* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		_tmp13_ = self->priv->dock_surface;
		_tmp14_ = plank_surface_get_Width (_tmp13_);
		_tmp15_ = _tmp14_;
		_tmp11_ = _tmp15_ != width;
	}
	if (_tmp11_) {
		_tmp10_ = TRUE;
	} else {
		PlankSurface* _tmp16_;
		gint _tmp17_;
		gint _tmp18_;
		_tmp16_ = self->priv->dock_surface;
		_tmp17_ = plank_surface_get_Height (_tmp16_);
		_tmp18_ = _tmp17_;
		_tmp10_ = _tmp18_ != height;
	}
	if (_tmp10_) {
		PlankSurface* dummy_surface = NULL;
		cairo_surface_t* _tmp19_;
		PlankSurface* _tmp20_;
		PlankDockTheme* _tmp21_;
		GtkPositionType _tmp22_;
		PlankSurface* _tmp23_;
		PlankSurface* _tmp24_;
		_tmp19_ = cairo_get_target (cr);
		_tmp20_ = plank_surface_new_with_cairo_surface (1, 1, _tmp19_);
		dummy_surface = _tmp20_;
		_tmp21_ = self->priv->dock_theme;
		_tmp22_ = position;
		_tmp23_ = dummy_surface;
		_tmp24_ = plank_dock_theme_create_background (_tmp21_, width / self->priv->ui_scale_factor, height / self->priv->ui_scale_factor, _tmp22_, _tmp23_);
		_g_object_unref0 (self->priv->dock_surface);
		self->priv->dock_surface = _tmp24_;
		_g_object_unref0 (dummy_surface);
	}
	x = (gfloat) 0;
	y = (gfloat) 0;
	_tmp25_ = position;
	switch (_tmp25_) {
		case GTK_POS_RIGHT:
		{
			x = self->priv->dock_y_offset;
			break;
		}
		case GTK_POS_BOTTOM:
		{
			y = self->priv->dock_y_offset / self->priv->ui_scale_factor;
			break;
		}
		case GTK_POS_LEFT:
		{
			x = (gfloat) 0;
			break;
		}
		case GTK_POS_TOP:
		{
			y = (gfloat) 0;
			break;
		}
		default:
		break;
	}
	cairo_save (cr);
	cairo_scale (cr, (gdouble) self->priv->ui_scale_factor, (gdouble) self->priv->ui_scale_factor);
	_tmp26_ = self->priv->dock_surface;
	_tmp27_ = plank_surface_get_Internal (_tmp26_);
	_tmp28_ = _tmp27_;
	cairo_set_source_surface (cr, _tmp28_, (gdouble) x, (gdouble) y);
	cairo_paint (cr);
	cairo_restore (cr);
	result = FALSE;
	return result;
}

static void
gala_window_switcher_place_dock (GalaWindowSwitcher* self)
{
	gint icon_size = 0;
	PlankDockPreferences* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gfloat scaled_icon_size = 0.0F;
	gint line_width = 0;
	PlankDockTheme* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gdouble horiz_padding = 0.0;
	PlankDockTheme* _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gfloat item_padding = 0.0F;
	PlankDockTheme* _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	gdouble _tmp12_ = 0.0;
	gint items_offset = 0;
	PlankDockPreferences* _tmp18_;
	ClutterActor* _tmp31_;
	g_return_if_fail (self != NULL);
	self->priv->ui_scale_factor = gala_internal_utils_get_ui_scaling_factor ();
	_tmp0_ = self->priv->dock_settings;
	_tmp1_ = plank_dock_preferences_get_IconSize (_tmp0_);
	_tmp2_ = _tmp1_;
	icon_size = _tmp2_ * self->priv->ui_scale_factor;
	scaled_icon_size = icon_size / 10.0f;
	_tmp3_ = self->priv->dock_theme;
	_tmp4_ = plank_theme_get_LineWidth ((PlankTheme*) _tmp3_);
	_tmp5_ = _tmp4_;
	line_width = _tmp5_ * self->priv->ui_scale_factor;
	_tmp6_ = self->priv->dock_theme;
	_tmp7_ = plank_dock_theme_get_HorizPadding (_tmp6_);
	_tmp8_ = _tmp7_;
	horiz_padding = _tmp8_ * scaled_icon_size;
	_tmp9_ = self->priv->dock_theme;
	_tmp10_ = plank_dock_theme_get_ItemPadding (_tmp9_);
	_tmp11_ = _tmp10_;
	item_padding = ((gfloat) _tmp11_) * scaled_icon_size;
	if (horiz_padding > ((gdouble) 0)) {
		_tmp12_ = horiz_padding;
	} else {
		_tmp12_ = (gdouble) 0;
	}
	items_offset = (gint) (((2 * line_width) + _tmp12_) + (item_padding / 2));
	if (self->priv->n_dock_items > 0) {
		self->priv->dock_width = (self->priv->n_dock_items * (item_padding + icon_size)) + (items_offset * 2);
	} else {
		gfloat _tmp13_ = 0.0F;
		MetaWindowActor* _tmp14_;
		_tmp14_ = self->priv->dock_window;
		if (_tmp14_ != NULL) {
			MetaWindowActor* _tmp15_;
			gfloat _tmp16_;
			gfloat _tmp17_;
			_tmp15_ = self->priv->dock_window;
			_tmp16_ = clutter_actor_get_width ((ClutterActor*) _tmp15_);
			_tmp17_ = _tmp16_;
			_tmp13_ = _tmp17_;
		} else {
			_tmp13_ = 300.0f;
		}
		self->priv->dock_width = _tmp13_;
	}
	_tmp18_ = self->priv->dock_settings;
	if (plank_dock_preferences_is_horizontal_dock (_tmp18_)) {
		ClutterActor* _tmp19_;
		ClutterActor* _tmp20_;
		ClutterActor* _tmp21_;
		ClutterActor* _tmp22_;
		ClutterActor* _tmp23_;
		ClutterActor* _tmp24_;
		_tmp19_ = self->priv->dock;
		clutter_actor_set_width (_tmp19_, self->priv->dock_width);
		_tmp20_ = self->priv->dock;
		g_object_set (_tmp20_, "translation-x", ceilf ((-self->priv->dock_width) / 2.0f), NULL);
		_tmp21_ = self->priv->dock;
		_tmp22_ = clutter_actor_get_first_child (_tmp21_);
		clutter_actor_set_margin_left (_tmp22_, (gfloat) items_offset);
		_tmp23_ = self->priv->dock;
		_tmp24_ = clutter_actor_get_last_child (_tmp23_);
		clutter_actor_set_margin_right (_tmp24_, (gfloat) items_offset);
	} else {
		ClutterActor* _tmp25_;
		ClutterActor* _tmp26_;
		ClutterActor* _tmp27_;
		ClutterActor* _tmp28_;
		ClutterActor* _tmp29_;
		ClutterActor* _tmp30_;
		_tmp25_ = self->priv->dock;
		clutter_actor_set_height (_tmp25_, self->priv->dock_width);
		_tmp26_ = self->priv->dock;
		g_object_set (_tmp26_, "translation-y", ceilf ((-self->priv->dock_width) / 2.0f), NULL);
		_tmp27_ = self->priv->dock;
		_tmp28_ = clutter_actor_get_first_child (_tmp27_);
		clutter_actor_set_margin_top (_tmp28_, (gfloat) items_offset);
		_tmp29_ = self->priv->dock;
		_tmp30_ = clutter_actor_get_last_child (_tmp29_);
		clutter_actor_set_margin_bottom (_tmp30_, (gfloat) items_offset);
	}
	_tmp31_ = self->priv->dock;
	clutter_actor_set_opacity (_tmp31_, (guint) 255);
}

static void
gala_window_switcher_animate_dock_width (GalaWindowSwitcher* self)
{
	ClutterActor* _tmp0_;
	ClutterActor* _tmp1_;
	ClutterActor* _tmp2_;
	gfloat dest_width = 0.0F;
	PlankDockPreferences* _tmp3_;
	ClutterActor* _tmp24_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->dock;
	clutter_actor_save_easing_state (_tmp0_);
	_tmp1_ = self->priv->dock;
	clutter_actor_set_easing_duration (_tmp1_, (guint) 250);
	_tmp2_ = self->priv->dock;
	clutter_actor_set_easing_mode (_tmp2_, CLUTTER_EASE_OUT_CUBIC);
	_tmp3_ = self->priv->dock_settings;
	if (plank_dock_preferences_is_horizontal_dock (_tmp3_)) {
		ClutterActor* _tmp4_;
		ClutterLayoutManager* _tmp5_;
		ClutterLayoutManager* _tmp6_;
		ClutterActor* _tmp7_;
		ClutterActor* _tmp8_;
		gfloat _tmp9_;
		gfloat _tmp10_;
		gfloat _tmp11_ = 0.0F;
		ClutterActor* _tmp12_;
		ClutterActor* _tmp13_;
		_tmp4_ = self->priv->dock;
		_tmp5_ = clutter_actor_get_layout_manager (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = self->priv->dock;
		_tmp8_ = self->priv->dock;
		_tmp9_ = clutter_actor_get_height (_tmp8_);
		_tmp10_ = _tmp9_;
		clutter_layout_manager_get_preferred_width (_tmp6_, (ClutterContainer*) _tmp7_, _tmp10_, NULL, &_tmp11_);
		dest_width = _tmp11_;
		_tmp12_ = self->priv->dock;
		clutter_actor_set_width (_tmp12_, dest_width);
		_tmp13_ = self->priv->dock;
		g_object_set (_tmp13_, "translation-x", ceilf ((-dest_width) / 2.0f), NULL);
	} else {
		ClutterActor* _tmp14_;
		ClutterLayoutManager* _tmp15_;
		ClutterLayoutManager* _tmp16_;
		ClutterActor* _tmp17_;
		ClutterActor* _tmp18_;
		gfloat _tmp19_;
		gfloat _tmp20_;
		gfloat _tmp21_ = 0.0F;
		ClutterActor* _tmp22_;
		ClutterActor* _tmp23_;
		_tmp14_ = self->priv->dock;
		_tmp15_ = clutter_actor_get_layout_manager (_tmp14_);
		_tmp16_ = _tmp15_;
		_tmp17_ = self->priv->dock;
		_tmp18_ = self->priv->dock;
		_tmp19_ = clutter_actor_get_width (_tmp18_);
		_tmp20_ = _tmp19_;
		clutter_layout_manager_get_preferred_height (_tmp16_, (ClutterContainer*) _tmp17_, _tmp20_, NULL, &_tmp21_);
		dest_width = _tmp21_;
		_tmp22_ = self->priv->dock;
		clutter_actor_set_height (_tmp22_, dest_width);
		_tmp23_ = self->priv->dock;
		g_object_set (_tmp23_, "translation-y", ceilf ((-dest_width) / 2.0f), NULL);
	}
	_tmp24_ = self->priv->dock;
	clutter_actor_restore_easing_state (_tmp24_);
}

static void
gala_window_switcher_show_background (GalaWindowSwitcher* self)
{
	ClutterActor* _tmp0_;
	ClutterActor* _tmp1_;
	ClutterActor* _tmp2_;
	ClutterActor* _tmp3_;
	ClutterActor* _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->background;
	clutter_actor_save_easing_state (_tmp0_);
	_tmp1_ = self->priv->background;
	clutter_actor_set_easing_duration (_tmp1_, (guint) 250);
	_tmp2_ = self->priv->background;
	clutter_actor_set_easing_mode (_tmp2_, CLUTTER_EASE_OUT_CUBIC);
	_tmp3_ = self->priv->background;
	clutter_actor_set_opacity (_tmp3_, (guint) GALA_WINDOW_SWITCHER_BACKGROUND_OPACITY);
	_tmp4_ = self->priv->background;
	clutter_actor_restore_easing_state (_tmp4_);
}

static void
gala_window_switcher_hide_background (GalaWindowSwitcher* self)
{
	ClutterActor* _tmp0_;
	ClutterActor* _tmp1_;
	ClutterActor* _tmp2_;
	ClutterActor* _tmp3_;
	ClutterActor* _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->background;
	clutter_actor_save_easing_state (_tmp0_);
	_tmp1_ = self->priv->background;
	clutter_actor_set_easing_duration (_tmp1_, (guint) 250);
	_tmp2_ = self->priv->background;
	clutter_actor_set_easing_mode (_tmp2_, CLUTTER_EASE_OUT_CUBIC);
	_tmp3_ = self->priv->background;
	clutter_actor_set_opacity (_tmp3_, (guint) 0);
	_tmp4_ = self->priv->background;
	clutter_actor_restore_easing_state (_tmp4_);
}

static gboolean
___lambda45_ (GalaWindowSwitcher* self)
{
	GalaWindowManager* _tmp0_;
	MetaScreen* _tmp1_;
	MetaDisplay* _tmp2_;
	gboolean result = FALSE;
	_tmp0_ = self->priv->_wm;
	_tmp1_ = meta_plugin_get_screen ((MetaPlugin*) _tmp0_);
	_tmp2_ = meta_screen_get_display (_tmp1_);
	gala_window_switcher_close (self, (guint) meta_display_get_current_time (_tmp2_));
	result = FALSE;
	return result;
}

static gboolean
____lambda45__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda45_ ((GalaWindowSwitcher*) self);
	return result;
}

static gboolean
gala_window_switcher_clicked_icon (GalaWindowSwitcher* self,
                                   ClutterButtonEvent* event)
{
	GalaWindowIcon* icon = NULL;
	ClutterActor* _tmp0_;
	GalaWindowIcon* _tmp1_;
	GalaWindowIcon* _tmp2_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = event->source;
	icon = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GALA_TYPE_WINDOW_ICON, GalaWindowIcon);
	_tmp1_ = self->priv->current_window;
	_tmp2_ = icon;
	if (_tmp1_ != _tmp2_) {
		GalaWindowIcon* _tmp3_;
		GalaWindowIcon* _tmp4_;
		_tmp3_ = icon;
		_tmp4_ = _g_object_ref0 (_tmp3_);
		_g_object_unref0 (self->priv->current_window);
		self->priv->current_window = _tmp4_;
		gala_window_switcher_dim_windows (self);
		g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 250, ____lambda45__gsource_func, g_object_ref (self), g_object_unref);
	} else {
		gala_window_switcher_close (self, (guint) event->time);
	}
	result = TRUE;
	return result;
}

static void
gala_window_switcher_window_removed (GalaWindowSwitcher* self,
                                     ClutterActor* actor)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (actor != NULL);
	self->priv->clone_sort_order = g_list_remove (self->priv->clone_sort_order, actor);
}

static void
gala_window_switcher_icon_removed (GalaWindowSwitcher* self,
                                   ClutterActor* actor)
{
	ClutterActor* _tmp0_;
	GalaWindowIcon* _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (actor != NULL);
	_tmp0_ = self->priv->dock;
	if (clutter_actor_get_n_children (_tmp0_) == 1) {
		GalaWindowManager* _tmp1_;
		MetaScreen* _tmp2_;
		MetaDisplay* _tmp3_;
		_tmp1_ = self->priv->_wm;
		_tmp2_ = meta_plugin_get_screen ((MetaPlugin*) _tmp1_);
		_tmp3_ = meta_screen_get_display (_tmp2_);
		gala_window_switcher_close (self, (guint) meta_display_get_current_time (_tmp3_));
		return;
	}
	_tmp4_ = self->priv->current_window;
	if (actor == G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, clutter_actor_get_type (), ClutterActor)) {
		GalaWindowIcon* _tmp5_;
		ClutterActor* _tmp6_;
		GalaWindowIcon* _tmp7_;
		GalaWindowIcon* _tmp8_;
		_tmp5_ = self->priv->current_window;
		_tmp6_ = clutter_actor_get_next_sibling ((ClutterActor*) _tmp5_);
		_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GALA_TYPE_WINDOW_ICON, GalaWindowIcon));
		_g_object_unref0 (self->priv->current_window);
		self->priv->current_window = _tmp7_;
		_tmp8_ = self->priv->current_window;
		if (_tmp8_ == NULL) {
			ClutterActor* _tmp9_;
			ClutterActor* _tmp10_;
			GalaWindowIcon* _tmp11_;
			_tmp9_ = self->priv->dock;
			_tmp10_ = clutter_actor_get_first_child (_tmp9_);
			_tmp11_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, GALA_TYPE_WINDOW_ICON, GalaWindowIcon));
			_g_object_unref0 (self->priv->current_window);
			self->priv->current_window = _tmp11_;
		}
		gala_window_switcher_dim_windows (self);
	}
	gala_window_switcher_animate_dock_width (self);
}

static gboolean
gala_window_switcher_real_key_release_event (ClutterActor* base,
                                             ClutterKeyEvent* event)
{
	GalaWindowSwitcher * self;
	gboolean result = FALSE;
	self = (GalaWindowSwitcher*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	if ((gala_window_switcher_get_current_modifiers (self) & self->priv->modifier_mask) == 0) {
		gala_window_switcher_close (self, (guint) event->time);
	}
	result = TRUE;
	return result;
}

static void
gala_window_switcher_real_key_focus_out (ClutterActor* base)
{
	GalaWindowSwitcher * self;
	GalaWindowManager* _tmp0_;
	MetaScreen* _tmp1_;
	MetaDisplay* _tmp2_;
	self = (GalaWindowSwitcher*) base;
	_tmp0_ = self->priv->_wm;
	_tmp1_ = meta_plugin_get_screen ((MetaPlugin*) _tmp0_);
	_tmp2_ = meta_screen_get_display (_tmp1_);
	gala_window_switcher_close (self, (guint) meta_display_get_current_time (_tmp2_));
}

static gboolean
__lambda47_ (GalaWindowSwitcher* self,
             MetaKeyBinding* binding)
{
	gchar* name = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	const gchar* _tmp5_;
	gboolean result = FALSE;
	g_return_val_if_fail (binding != NULL, FALSE);
	if (!meta_key_binding_is_builtin (binding)) {
		result = TRUE;
		return result;
	}
	_tmp0_ = meta_key_binding_get_name (binding);
	_tmp1_ = g_strdup (_tmp0_);
	name = _tmp1_;
	_tmp5_ = name;
	if (g_strcmp0 (_tmp5_, "switch-applications") == 0) {
		_tmp4_ = TRUE;
	} else {
		const gchar* _tmp6_;
		_tmp6_ = name;
		_tmp4_ = g_strcmp0 (_tmp6_, "switch-applications-backward") == 0;
	}
	if (_tmp4_) {
		_tmp3_ = TRUE;
	} else {
		const gchar* _tmp7_;
		_tmp7_ = name;
		_tmp3_ = g_strcmp0 (_tmp7_, "switch-windows") == 0;
	}
	if (_tmp3_) {
		_tmp2_ = TRUE;
	} else {
		const gchar* _tmp8_;
		_tmp8_ = name;
		_tmp2_ = g_strcmp0 (_tmp8_, "switch-windows-backward") == 0;
	}
	result = !_tmp2_;
	_g_free0 (name);
	return result;
}

static gboolean
___lambda47__gala_keybinding_filter (MetaKeyBinding* binding,
                                     gpointer self)
{
	gboolean result;
	result = __lambda47_ ((GalaWindowSwitcher*) self, binding);
	return result;
}

void
gala_window_switcher_handle_switch_windows (MetaDisplay* display,
                                            MetaScreen* screen,
                                            MetaWindow* window,
                                            ClutterKeyEvent* event,
                                            MetaKeyBinding* binding,
                                            GalaWindowSwitcher* self)
{
	gint64 now = 0LL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	MetaWorkspace* workspace = NULL;
	MetaWorkspace* _tmp3_;
	MetaWorkspace* _tmp4_;
	gchar* binding_name = NULL;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gboolean backward = FALSE;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_;
	gboolean _tmp11_;
	MetaWorkspace* _tmp14_;
	MetaWorkspace* _tmp15_;
	GalaWindowIcon* _tmp16_;
	GalaWindowManager* _tmp17_;
	GalaModalProxy* _tmp18_;
	GalaModalProxy* _tmp19_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (display != NULL);
	g_return_if_fail (screen != NULL);
	g_return_if_fail (event != NULL);
	g_return_if_fail (binding != NULL);
	now = g_get_monotonic_time () / 1000;
	if ((now - self->priv->last_switch) < ((gint64) GALA_WINDOW_SWITCHER_MIN_DELTA)) {
		return;
	}
	g_object_get ((ClutterActor*) self, "visible", &_tmp1_, NULL);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		_tmp0_ = self->priv->closing;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gala_window_switcher_close_cleanup (self);
	}
	self->priv->last_switch = now;
	_tmp3_ = meta_screen_get_active_workspace (screen);
	_tmp4_ = _g_object_ref0 (_tmp3_);
	workspace = _tmp4_;
	_tmp5_ = meta_key_binding_get_name (binding);
	_tmp6_ = g_strdup (_tmp5_);
	binding_name = _tmp6_;
	_tmp7_ = binding_name;
	backward = g_str_has_suffix (_tmp7_, "-backward");
	_tmp8_ = binding_name;
	if (g_strcmp0 (_tmp8_, "switch-applications") == 0) {
		backward = (gala_window_switcher_get_current_modifiers (self) & CLUTTER_SHIFT_MASK) != 0;
	}
	g_object_get ((ClutterActor*) self, "visible", &_tmp10_, NULL);
	_tmp11_ = _tmp10_;
	if (_tmp11_) {
		_tmp9_ = !self->priv->closing;
	} else {
		_tmp9_ = FALSE;
	}
	if (_tmp9_) {
		MetaWorkspace* _tmp12_;
		GalaWindowIcon* _tmp13_;
		_tmp12_ = workspace;
		_tmp13_ = gala_window_switcher_next_window (self, _tmp12_, backward);
		_g_object_unref0 (self->priv->current_window);
		self->priv->current_window = _tmp13_;
		gala_window_switcher_dim_windows (self);
		_g_free0 (binding_name);
		_g_object_unref0 (workspace);
		return;
	}
	_tmp14_ = workspace;
	if (!gala_window_switcher_collect_windows (self, _tmp14_)) {
		_g_free0 (binding_name);
		_g_object_unref0 (workspace);
		return;
	}
	gala_window_switcher_set_primary_modifier (self, meta_key_binding_get_mask (binding));
	_tmp15_ = workspace;
	_tmp16_ = gala_window_switcher_next_window (self, _tmp15_, backward);
	_g_object_unref0 (self->priv->current_window);
	self->priv->current_window = _tmp16_;
	gala_window_switcher_place_dock (self);
	g_object_set ((ClutterActor*) self, "visible", TRUE, NULL);
	self->priv->closing = FALSE;
	_tmp17_ = self->priv->_wm;
	_tmp18_ = gala_window_manager_push_modal (_tmp17_);
	_g_object_unref0 (self->priv->modal_proxy);
	self->priv->modal_proxy = _tmp18_;
	_tmp19_ = self->priv->modal_proxy;
	gala_modal_proxy_set_keybinding_filter (_tmp19_, ___lambda47__gala_keybinding_filter, g_object_ref (self), g_object_unref);
	gala_window_switcher_animate_dock_width (self);
	gala_window_switcher_show_background (self);
	gala_window_switcher_dim_windows (self);
	clutter_actor_grab_key_focus ((ClutterActor*) self);
	if ((gala_window_switcher_get_current_modifiers (self) & self->priv->modifier_mask) == 0) {
		GalaWindowManager* _tmp20_;
		MetaScreen* _tmp21_;
		MetaDisplay* _tmp22_;
		_tmp20_ = self->priv->_wm;
		_tmp21_ = meta_plugin_get_screen ((MetaPlugin*) _tmp20_);
		_tmp22_ = meta_screen_get_display (_tmp21_);
		gala_window_switcher_close (self, (guint) meta_display_get_current_time (_tmp22_));
	}
	_g_free0 (binding_name);
	_g_object_unref0 (workspace);
}

static void
gala_window_switcher_close_cleanup (GalaWindowSwitcher* self)
{
	MetaScreen* screen = NULL;
	GalaWindowManager* _tmp0_;
	MetaScreen* _tmp1_;
	MetaScreen* _tmp2_;
	MetaWorkspace* workspace = NULL;
	MetaScreen* _tmp3_;
	MetaWorkspace* _tmp4_;
	MetaWorkspace* _tmp5_;
	ClutterActor* _tmp6_;
	ClutterActor* _tmp7_;
	GList* window_actors = NULL;
	MetaScreen* _tmp8_;
	GList* _tmp9_;
	GList* _tmp10_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_wm;
	_tmp1_ = meta_plugin_get_screen ((MetaPlugin*) _tmp0_);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	screen = _tmp2_;
	_tmp3_ = screen;
	_tmp4_ = meta_screen_get_active_workspace (_tmp3_);
	_tmp5_ = _g_object_ref0 (_tmp4_);
	workspace = _tmp5_;
	_tmp6_ = self->priv->dock;
	clutter_actor_destroy_all_children (_tmp6_);
	_g_object_unref0 (self->priv->dock_window);
	self->priv->dock_window = NULL;
	g_object_set ((ClutterActor*) self, "visible", FALSE, NULL);
	self->priv->closing = FALSE;
	_tmp7_ = self->priv->window_clones;
	clutter_actor_destroy_all_children (_tmp7_);
	_tmp8_ = screen;
	_tmp9_ = meta_get_window_actors (_tmp8_);
	window_actors = _tmp9_;
	_tmp10_ = window_actors;
	{
		GList* actor_collection = NULL;
		GList* actor_it = NULL;
		actor_collection = _tmp10_;
		for (actor_it = actor_collection; actor_it != NULL; actor_it = actor_it->next) {
			MetaWindowActor* actor = NULL;
			actor = (MetaWindowActor*) actor_it->data;
			{
				MetaWindowActor* _tmp11_;
				MetaWindow* window = NULL;
				MetaWindowActor* _tmp12_;
				MetaWindow* _tmp13_;
				gboolean _tmp14_ = FALSE;
				MetaWindow* _tmp15_;
				MetaWorkspace* _tmp16_;
				MetaWorkspace* _tmp17_;
				_tmp11_ = actor;
				if (meta_window_actor_is_destroyed (_tmp11_)) {
					continue;
				}
				_tmp12_ = actor;
				_tmp13_ = meta_window_actor_get_meta_window (_tmp12_);
				window = _tmp13_;
				_tmp15_ = window;
				_tmp16_ = meta_window_get_workspace (_tmp15_);
				_tmp17_ = workspace;
				if (_tmp16_ == _tmp17_) {
					MetaWindow* _tmp18_;
					_tmp18_ = window;
					_tmp14_ = meta_window_showing_on_its_workspace (_tmp18_);
				} else {
					_tmp14_ = FALSE;
				}
				if (_tmp14_) {
					MetaWindowActor* _tmp19_;
					_tmp19_ = actor;
					clutter_actor_show ((ClutterActor*) _tmp19_);
				}
			}
		}
	}
	_g_object_unref0 (workspace);
	_g_object_unref0 (screen);
}

static void
___lambda46_ (GalaWindowSwitcher* self)
{
	gala_window_switcher_close_cleanup (self);
}

static void
____lambda46__clutter_timeline_completed (ClutterTimeline* _sender,
                                          gpointer self)
{
	___lambda46_ ((GalaWindowSwitcher*) self);
}

static void
gala_window_switcher_close (GalaWindowSwitcher* self,
                            guint time)
{
	GList* _tmp0_;
	GalaWindowIcon* _tmp22_;
	GalaWindowManager* _tmp26_;
	GalaModalProxy* _tmp27_;
	MetaWindowActor* _tmp28_;
	gfloat _tmp30_ = 0.0F;
	gfloat dest_width = 0.0F;
	ClutterActor* _tmp31_;
	MetaWindowActor* _tmp32_;
	ClutterActor* _tmp39_;
	ClutterActor* _tmp40_;
	ClutterActor* _tmp41_;
	PlankDockPreferences* _tmp42_;
	ClutterActor* _tmp47_;
	ClutterActor* _tmp48_;
	ClutterTransition* transition = NULL;
	ClutterActor* _tmp49_;
	ClutterTransition* _tmp50_;
	ClutterTransition* _tmp51_;
	ClutterTransition* _tmp52_;
	g_return_if_fail (self != NULL);
	if (self->priv->closing) {
		return;
	}
	self->priv->closing = TRUE;
	self->priv->last_switch = (gint64) 0;
	_tmp0_ = self->priv->clone_sort_order;
	{
		GList* actor_collection = NULL;
		GList* actor_it = NULL;
		actor_collection = _tmp0_;
		for (actor_it = actor_collection; actor_it != NULL; actor_it = actor_it->next) {
			ClutterActor* actor = NULL;
			actor = (ClutterActor*) actor_it->data;
			{
				GalaSafeWindowClone* clone = NULL;
				ClutterActor* _tmp1_;
				GalaSafeWindowClone* _tmp2_;
				MetaWindow* _tmp3_;
				MetaWindow* _tmp4_;
				GalaWindowIcon* _tmp5_;
				MetaWindow* _tmp6_;
				MetaWindow* _tmp7_;
				GalaSafeWindowClone* _tmp8_;
				ClutterActor* _tmp9_;
				GalaSafeWindowClone* _tmp10_;
				GalaSafeWindowClone* _tmp11_;
				MetaWindow* _tmp12_;
				MetaWindow* _tmp13_;
				gboolean _tmp14_;
				gboolean _tmp15_;
				_tmp1_ = actor;
				clone = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GALA_TYPE_SAFE_WINDOW_CLONE, GalaSafeWindowClone);
				_tmp2_ = clone;
				_tmp3_ = gala_safe_window_clone_get_window (_tmp2_);
				_tmp4_ = _tmp3_;
				_tmp5_ = self->priv->current_window;
				_tmp6_ = gala_window_icon_get_window (_tmp5_);
				_tmp7_ = _tmp6_;
				if (_tmp4_ == _tmp7_) {
					continue;
				}
				_tmp8_ = clone;
				clutter_actor_remove_effect_by_name ((ClutterActor*) _tmp8_, "brightness");
				_tmp9_ = self->priv->window_clones;
				_tmp10_ = clone;
				clutter_actor_set_child_below_sibling (_tmp9_, (ClutterActor*) _tmp10_, NULL);
				_tmp11_ = clone;
				_tmp12_ = gala_safe_window_clone_get_window (_tmp11_);
				_tmp13_ = _tmp12_;
				g_object_get (_tmp13_, "minimized", &_tmp14_, NULL);
				_tmp15_ = _tmp14_;
				if (!_tmp15_) {
					GalaSafeWindowClone* _tmp16_;
					GalaSafeWindowClone* _tmp17_;
					GalaSafeWindowClone* _tmp18_;
					GalaSafeWindowClone* _tmp19_;
					GalaSafeWindowClone* _tmp20_;
					GalaSafeWindowClone* _tmp21_;
					_tmp16_ = clone;
					clutter_actor_save_easing_state ((ClutterActor*) _tmp16_);
					_tmp17_ = clone;
					clutter_actor_set_easing_duration ((ClutterActor*) _tmp17_, (guint) 150);
					_tmp18_ = clone;
					clutter_actor_set_easing_mode ((ClutterActor*) _tmp18_, CLUTTER_EASE_OUT_CUBIC);
					_tmp19_ = clone;
					clutter_actor_set_z_position ((ClutterActor*) _tmp19_, (gfloat) 0);
					_tmp20_ = clone;
					clutter_actor_set_opacity ((ClutterActor*) _tmp20_, (guint) 255);
					_tmp21_ = clone;
					clutter_actor_restore_easing_state ((ClutterActor*) _tmp21_);
				}
			}
		}
	}
	_tmp22_ = self->priv->current_window;
	if (_tmp22_ != NULL) {
		GalaWindowIcon* _tmp23_;
		MetaWindow* _tmp24_;
		MetaWindow* _tmp25_;
		_tmp23_ = self->priv->current_window;
		_tmp24_ = gala_window_icon_get_window (_tmp23_);
		_tmp25_ = _tmp24_;
		meta_window_activate (_tmp25_, (guint32) time);
		_g_object_unref0 (self->priv->current_window);
		self->priv->current_window = NULL;
	}
	_tmp26_ = self->priv->_wm;
	_tmp27_ = self->priv->modal_proxy;
	gala_window_manager_pop_modal (_tmp26_, _tmp27_);
	_tmp28_ = self->priv->dock_window;
	if (_tmp28_ != NULL) {
		MetaWindowActor* _tmp29_;
		_tmp29_ = self->priv->dock_window;
		clutter_actor_set_opacity ((ClutterActor*) _tmp29_, (guint) 0);
	}
	if (self->priv->dock_width > ((gfloat) 0)) {
		_tmp30_ = self->priv->dock_width;
	} else {
		_tmp30_ = 600.0f;
	}
	dest_width = _tmp30_;
	_tmp31_ = self->priv->dock;
	clutter_actor_set_child_above_sibling ((ClutterActor*) self, _tmp31_, NULL);
	_tmp32_ = self->priv->dock_window;
	if (_tmp32_ != NULL) {
		MetaWindowActor* _tmp33_;
		MetaWindowActor* _tmp34_;
		MetaWindowActor* _tmp35_;
		MetaWindowActor* _tmp36_;
		MetaWindowActor* _tmp37_;
		MetaWindowActor* _tmp38_;
		_tmp33_ = self->priv->dock_window;
		clutter_actor_show ((ClutterActor*) _tmp33_);
		_tmp34_ = self->priv->dock_window;
		clutter_actor_save_easing_state ((ClutterActor*) _tmp34_);
		_tmp35_ = self->priv->dock_window;
		clutter_actor_set_easing_mode ((ClutterActor*) _tmp35_, CLUTTER_LINEAR);
		_tmp36_ = self->priv->dock_window;
		clutter_actor_set_easing_duration ((ClutterActor*) _tmp36_, (guint) 250);
		_tmp37_ = self->priv->dock_window;
		clutter_actor_set_opacity ((ClutterActor*) _tmp37_, (guint) 255);
		_tmp38_ = self->priv->dock_window;
		clutter_actor_restore_easing_state ((ClutterActor*) _tmp38_);
	}
	gala_window_switcher_hide_background (self);
	_tmp39_ = self->priv->dock;
	clutter_actor_save_easing_state (_tmp39_);
	_tmp40_ = self->priv->dock;
	clutter_actor_set_easing_duration (_tmp40_, (guint) 250);
	_tmp41_ = self->priv->dock;
	clutter_actor_set_easing_mode (_tmp41_, CLUTTER_EASE_OUT_CUBIC);
	_tmp42_ = self->priv->dock_settings;
	if (plank_dock_preferences_is_horizontal_dock (_tmp42_)) {
		ClutterActor* _tmp43_;
		ClutterActor* _tmp44_;
		_tmp43_ = self->priv->dock;
		clutter_actor_set_width (_tmp43_, dest_width);
		_tmp44_ = self->priv->dock;
		g_object_set (_tmp44_, "translation-x", ceilf ((-dest_width) / 2.0f), NULL);
	} else {
		ClutterActor* _tmp45_;
		ClutterActor* _tmp46_;
		_tmp45_ = self->priv->dock;
		clutter_actor_set_height (_tmp45_, dest_width);
		_tmp46_ = self->priv->dock;
		g_object_set (_tmp46_, "translation-y", ceilf ((-dest_width) / 2.0f), NULL);
	}
	_tmp47_ = self->priv->dock;
	clutter_actor_set_opacity (_tmp47_, (guint) 0);
	_tmp48_ = self->priv->dock;
	clutter_actor_restore_easing_state (_tmp48_);
	_tmp49_ = self->priv->dock;
	_tmp50_ = clutter_actor_get_transition (_tmp49_, "opacity");
	_tmp51_ = _g_object_ref0 (_tmp50_);
	transition = _tmp51_;
	_tmp52_ = transition;
	if (_tmp52_ != NULL) {
		ClutterTransition* _tmp53_;
		_tmp53_ = transition;
		g_signal_connect_object ((ClutterTimeline*) _tmp53_, "completed", (GCallback) ____lambda46__clutter_timeline_completed, self, 0);
	} else {
		gala_window_switcher_close_cleanup (self);
	}
	_g_object_unref0 (transition);
}

static gboolean
_gala_window_switcher_clicked_icon_clutter_actor_button_release_event (ClutterActor* _sender,
                                                                       ClutterButtonEvent* event,
                                                                       gpointer self)
{
	gboolean result;
	result = gala_window_switcher_clicked_icon ((GalaWindowSwitcher*) self, event);
	return result;
}

static GalaWindowIcon*
gala_window_switcher_add_window (GalaWindowSwitcher* self,
                                 MetaWindow* window)
{
	MetaWindowActor* actor = NULL;
	GObject* _tmp0_;
	MetaWindowActor* _tmp1_;
	MetaWindowActor* _tmp2_;
	MetaWindowActor* _tmp3_;
	GalaSafeWindowClone* clone = NULL;
	GalaSafeWindowClone* _tmp4_;
	GalaSafeWindowClone* _tmp5_;
	MetaWindowActor* _tmp6_;
	gfloat _tmp7_;
	gfloat _tmp8_;
	GalaSafeWindowClone* _tmp9_;
	MetaWindowActor* _tmp10_;
	gfloat _tmp11_;
	gfloat _tmp12_;
	ClutterActor* _tmp13_;
	GalaSafeWindowClone* _tmp14_;
	GalaWindowIcon* icon = NULL;
	PlankDockPreferences* _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	GalaWindowIcon* _tmp18_;
	GalaWindowIcon* _tmp19_;
	GalaWindowIcon* _tmp20_;
	GalaWindowIcon* _tmp21_;
	GalaWindowIcon* _tmp22_;
	GalaWindowIcon* _tmp23_;
	GalaWindowIcon* _tmp24_;
	GalaWindowIcon* _tmp25_;
	ClutterActor* _tmp26_;
	GalaWindowIcon* _tmp27_;
	GalaWindowIcon* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (window != NULL, NULL);
	_tmp0_ = meta_window_get_compositor_private (window);
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, meta_window_actor_get_type ()) ? ((MetaWindowActor*) _tmp0_) : NULL);
	actor = _tmp1_;
	_tmp2_ = actor;
	if (_tmp2_ == NULL) {
		result = NULL;
		_g_object_unref0 (actor);
		return result;
	}
	_tmp3_ = actor;
	clutter_actor_hide ((ClutterActor*) _tmp3_);
	_tmp4_ = gala_safe_window_clone_new (window, TRUE);
	g_object_ref_sink (_tmp4_);
	clone = _tmp4_;
	_tmp5_ = clone;
	_tmp6_ = actor;
	_tmp7_ = clutter_actor_get_x ((ClutterActor*) _tmp6_);
	_tmp8_ = _tmp7_;
	clutter_actor_set_x ((ClutterActor*) _tmp5_, _tmp8_);
	_tmp9_ = clone;
	_tmp10_ = actor;
	_tmp11_ = clutter_actor_get_y ((ClutterActor*) _tmp10_);
	_tmp12_ = _tmp11_;
	clutter_actor_set_y ((ClutterActor*) _tmp9_, _tmp12_);
	_tmp13_ = self->priv->window_clones;
	_tmp14_ = clone;
	clutter_actor_add_child (_tmp13_, (ClutterActor*) _tmp14_);
	_tmp15_ = self->priv->dock_settings;
	_tmp16_ = plank_dock_preferences_get_IconSize (_tmp15_);
	_tmp17_ = _tmp16_;
	_tmp18_ = gala_window_icon_new (window, _tmp17_, self->priv->ui_scale_factor, TRUE);
	g_object_ref_sink (_tmp18_);
	icon = _tmp18_;
	_tmp19_ = icon;
	clutter_actor_set_reactive ((ClutterActor*) _tmp19_, TRUE);
	_tmp20_ = icon;
	clutter_actor_set_opacity ((ClutterActor*) _tmp20_, (guint) 100);
	_tmp21_ = icon;
	clutter_actor_set_x_expand ((ClutterActor*) _tmp21_, TRUE);
	_tmp22_ = icon;
	clutter_actor_set_y_expand ((ClutterActor*) _tmp22_, TRUE);
	_tmp23_ = icon;
	clutter_actor_set_x_align ((ClutterActor*) _tmp23_, CLUTTER_ACTOR_ALIGN_CENTER);
	_tmp24_ = icon;
	clutter_actor_set_y_align ((ClutterActor*) _tmp24_, CLUTTER_ACTOR_ALIGN_CENTER);
	_tmp25_ = icon;
	g_signal_connect_object ((ClutterActor*) _tmp25_, "button-release-event", (GCallback) _gala_window_switcher_clicked_icon_clutter_actor_button_release_event, self, 0);
	_tmp26_ = self->priv->dock;
	_tmp27_ = icon;
	clutter_actor_add_child (_tmp26_, (ClutterActor*) _tmp27_);
	result = icon;
	_g_object_unref0 (clone);
	_g_object_unref0 (actor);
	return result;
}

static void
gala_window_switcher_dim_windows (GalaWindowSwitcher* self)
{
	ClutterActor* _tmp0_;
	GList* _tmp1_;
	ClutterActor* _tmp24_;
	GList* _tmp25_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->window_clones;
	_tmp1_ = clutter_actor_get_children (_tmp0_);
	{
		GList* actor_collection = NULL;
		GList* actor_it = NULL;
		actor_collection = _tmp1_;
		for (actor_it = actor_collection; actor_it != NULL; actor_it = actor_it->next) {
			ClutterActor* actor = NULL;
			actor = (ClutterActor*) actor_it->data;
			{
				GalaSafeWindowClone* clone = NULL;
				ClutterActor* _tmp2_;
				ClutterActor* _tmp3_;
				ClutterActor* _tmp4_;
				ClutterActor* _tmp5_;
				GalaSafeWindowClone* _tmp6_;
				MetaWindow* _tmp7_;
				MetaWindow* _tmp8_;
				GalaWindowIcon* _tmp9_;
				MetaWindow* _tmp10_;
				MetaWindow* _tmp11_;
				ClutterActor* _tmp23_;
				_tmp2_ = actor;
				clone = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GALA_TYPE_SAFE_WINDOW_CLONE, GalaSafeWindowClone);
				_tmp3_ = actor;
				clutter_actor_save_easing_state (_tmp3_);
				_tmp4_ = actor;
				clutter_actor_set_easing_duration (_tmp4_, (guint) 250);
				_tmp5_ = actor;
				clutter_actor_set_easing_mode (_tmp5_, CLUTTER_EASE_IN_OUT_QUART);
				_tmp6_ = clone;
				_tmp7_ = gala_safe_window_clone_get_window (_tmp6_);
				_tmp8_ = _tmp7_;
				_tmp9_ = self->priv->current_window;
				_tmp10_ = gala_window_icon_get_window (_tmp9_);
				_tmp11_ = _tmp10_;
				if (_tmp8_ == _tmp11_) {
					ClutterActor* _tmp12_;
					ClutterActor* _tmp13_;
					ClutterActor* _tmp14_;
					ClutterActor* _tmp15_;
					_tmp12_ = self->priv->window_clones;
					_tmp13_ = actor;
					clutter_actor_set_child_above_sibling (_tmp12_, _tmp13_, NULL);
					_tmp14_ = actor;
					clutter_actor_remove_effect_by_name (_tmp14_, "brightness");
					_tmp15_ = actor;
					clutter_actor_set_z_position (_tmp15_, (gfloat) 0);
				} else {
					ClutterActor* _tmp16_;
					ClutterEffect* _tmp17_;
					ClutterActor* _tmp22_;
					_tmp16_ = actor;
					_tmp17_ = clutter_actor_get_effect (_tmp16_, "brightness");
					if (_tmp17_ == NULL) {
						ClutterBrightnessContrastEffect* brightness_effect = NULL;
						ClutterBrightnessContrastEffect* _tmp18_;
						ClutterBrightnessContrastEffect* _tmp19_;
						ClutterActor* _tmp20_;
						ClutterBrightnessContrastEffect* _tmp21_;
						_tmp18_ = (ClutterBrightnessContrastEffect*) clutter_brightness_contrast_effect_new ();
						g_object_ref_sink (_tmp18_);
						brightness_effect = _tmp18_;
						_tmp19_ = brightness_effect;
						clutter_brightness_contrast_effect_set_brightness (_tmp19_, GALA_WINDOW_SWITCHER_DIM_WINDOW_BRIGHTNESS);
						_tmp20_ = actor;
						_tmp21_ = brightness_effect;
						clutter_actor_add_effect_with_name (_tmp20_, "brightness", (ClutterEffect*) _tmp21_);
						_g_object_unref0 (brightness_effect);
					}
					_tmp22_ = actor;
					clutter_actor_set_z_position (_tmp22_, (gfloat) -100);
				}
				_tmp23_ = actor;
				clutter_actor_restore_easing_state (_tmp23_);
			}
		}
		(actor_collection == NULL) ? NULL : (actor_collection = (g_list_free (actor_collection), NULL));
	}
	_tmp24_ = self->priv->dock;
	_tmp25_ = clutter_actor_get_children (_tmp24_);
	{
		GList* actor_collection = NULL;
		GList* actor_it = NULL;
		actor_collection = _tmp25_;
		for (actor_it = actor_collection; actor_it != NULL; actor_it = actor_it->next) {
			ClutterActor* actor = NULL;
			actor = (ClutterActor*) actor_it->data;
			{
				GalaWindowIcon* icon = NULL;
				ClutterActor* _tmp26_;
				GalaWindowIcon* _tmp27_;
				GalaWindowIcon* _tmp28_;
				GalaWindowIcon* _tmp29_;
				GalaWindowIcon* _tmp30_;
				GalaWindowIcon* _tmp31_;
				GalaWindowIcon* _tmp34_;
				_tmp26_ = actor;
				icon = G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, GALA_TYPE_WINDOW_ICON, GalaWindowIcon);
				_tmp27_ = icon;
				clutter_actor_save_easing_state ((ClutterActor*) _tmp27_);
				_tmp28_ = icon;
				clutter_actor_set_easing_duration ((ClutterActor*) _tmp28_, (guint) 100);
				_tmp29_ = icon;
				clutter_actor_set_easing_mode ((ClutterActor*) _tmp29_, CLUTTER_LINEAR);
				_tmp30_ = icon;
				_tmp31_ = self->priv->current_window;
				if (_tmp30_ == _tmp31_) {
					GalaWindowIcon* _tmp32_;
					_tmp32_ = icon;
					clutter_actor_set_opacity ((ClutterActor*) _tmp32_, (guint) 255);
				} else {
					GalaWindowIcon* _tmp33_;
					_tmp33_ = icon;
					clutter_actor_set_opacity ((ClutterActor*) _tmp33_, (guint) 100);
				}
				_tmp34_ = icon;
				clutter_actor_restore_easing_state ((ClutterActor*) _tmp34_);
			}
		}
		(actor_collection == NULL) ? NULL : (actor_collection = (g_list_free (actor_collection), NULL));
	}
}

/**
         * Adds the suitable windows on the given workspace to the switcher
         *
         * @return whether the switcher should actually be started or if there are
         *         not enough windows
         */
static gboolean
_vala_string_array_contains (gchar* * stack,
                             int stack_length,
                             const gchar* needle)
{
	int i;
	for (i = 0; i < stack_length; i++) {
		if (g_strcmp0 (stack[i], needle) == 0) {
			return TRUE;
		}
	}
	return FALSE;
}

static gboolean
gala_window_switcher_collect_windows (GalaWindowSwitcher* self,
                                      MetaWorkspace* workspace)
{
	MetaScreen* screen = NULL;
	MetaScreen* _tmp0_;
	MetaScreen* _tmp1_;
	MetaDisplay* display = NULL;
	MetaScreen* _tmp2_;
	MetaDisplay* _tmp3_;
	MetaDisplay* _tmp4_;
	GList* windows = NULL;
	MetaDisplay* _tmp5_;
	GList* _tmp6_;
	MetaWindow* current = NULL;
	MetaDisplay* _tmp7_;
	MetaWindow* _tmp8_;
	MetaWindow* _tmp9_;
	GList* _tmp10_;
	GList* _tmp11_;
	GList* _tmp22_;
	ClutterActor* _tmp29_;
	GList* _tmp30_;
	GList* _tmp31_;
	GList* _tmp32_;
	GalaWindowIcon* _tmp33_;
	GList* window_actors = NULL;
	MetaScreen* _tmp37_;
	GList* _tmp38_;
	GList* _tmp39_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (workspace != NULL, FALSE);
	_tmp0_ = meta_workspace_get_screen (workspace);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	screen = _tmp1_;
	_tmp2_ = screen;
	_tmp3_ = meta_screen_get_display (_tmp2_);
	_tmp4_ = _g_object_ref0 (_tmp3_);
	display = _tmp4_;
	_tmp5_ = display;
	_tmp6_ = meta_display_get_tab_list (_tmp5_, META_TAB_LIST_NORMAL, workspace);
	windows = _tmp6_;
	_tmp7_ = display;
	_tmp8_ = meta_display_get_tab_current (_tmp7_, META_TAB_LIST_NORMAL, workspace);
	_tmp9_ = _g_object_ref0 (_tmp8_);
	current = _tmp9_;
	_tmp10_ = windows;
	if (g_list_length (_tmp10_) < ((guint) 1)) {
		result = FALSE;
		_g_object_unref0 (current);
		(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
		_g_object_unref0 (display);
		_g_object_unref0 (screen);
		return result;
	}
	_tmp11_ = windows;
	if (g_list_length (_tmp11_) == ((guint) 1)) {
		MetaWindow* window = NULL;
		GList* _tmp12_;
		gconstpointer _tmp13_;
		MetaWindow* _tmp14_;
		MetaWindow* _tmp15_;
		gboolean _tmp16_;
		gboolean _tmp17_;
		MetaWindow* _tmp20_;
		MetaDisplay* _tmp21_;
		_tmp12_ = windows;
		_tmp13_ = _tmp12_->data;
		_tmp14_ = _g_object_ref0 ((MetaWindow*) _tmp13_);
		window = _tmp14_;
		_tmp15_ = window;
		g_object_get (_tmp15_, "minimized", &_tmp16_, NULL);
		_tmp17_ = _tmp16_;
		if (_tmp17_) {
			MetaWindow* _tmp18_;
			_tmp18_ = window;
			meta_window_unminimize (_tmp18_);
		} else {
			MetaScreen* _tmp19_;
			_tmp19_ = screen;
			gala_utils_bell (_tmp19_);
		}
		_tmp20_ = window;
		_tmp21_ = display;
		meta_window_activate (_tmp20_, meta_display_get_current_time (_tmp21_));
		result = FALSE;
		_g_object_unref0 (window);
		_g_object_unref0 (current);
		(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
		_g_object_unref0 (display);
		_g_object_unref0 (screen);
		return result;
	}
	_tmp22_ = windows;
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp22_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			MetaWindow* window = NULL;
			window = (MetaWindow*) window_it->data;
			{
				GalaWindowIcon* clone = NULL;
				MetaWindow* _tmp23_;
				GalaWindowIcon* _tmp24_;
				MetaWindow* _tmp25_;
				MetaWindow* _tmp26_;
				_tmp23_ = window;
				_tmp24_ = gala_window_switcher_add_window (self, _tmp23_);
				clone = _tmp24_;
				_tmp25_ = window;
				_tmp26_ = current;
				if (_tmp25_ == _tmp26_) {
					GalaWindowIcon* _tmp27_;
					GalaWindowIcon* _tmp28_;
					_tmp27_ = clone;
					_tmp28_ = _g_object_ref0 (_tmp27_);
					_g_object_unref0 (self->priv->current_window);
					self->priv->current_window = _tmp28_;
				}
				_g_object_unref0 (clone);
			}
		}
	}
	_tmp29_ = self->priv->window_clones;
	_tmp30_ = clutter_actor_get_children (_tmp29_);
	_tmp31_ = _tmp30_;
	_tmp32_ = g_list_copy (_tmp31_);
	(self->priv->clone_sort_order == NULL) ? NULL : (self->priv->clone_sort_order = (g_list_free (self->priv->clone_sort_order), NULL));
	self->priv->clone_sort_order = _tmp32_;
	(_tmp31_ == NULL) ? NULL : (_tmp31_ = (g_list_free (_tmp31_), NULL));
	_tmp33_ = self->priv->current_window;
	if (_tmp33_ == NULL) {
		ClutterActor* _tmp34_;
		ClutterActor* _tmp35_;
		GalaWindowIcon* _tmp36_;
		_tmp34_ = self->priv->dock;
		_tmp35_ = clutter_actor_get_child_at_index (_tmp34_, 0);
		_tmp36_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp35_, GALA_TYPE_WINDOW_ICON, GalaWindowIcon));
		_g_object_unref0 (self->priv->current_window);
		self->priv->current_window = _tmp36_;
	}
	_tmp37_ = screen;
	_tmp38_ = meta_get_window_actors (_tmp37_);
	window_actors = _tmp38_;
	_tmp39_ = window_actors;
	{
		GList* actor_collection = NULL;
		GList* actor_it = NULL;
		actor_collection = _tmp39_;
		for (actor_it = actor_collection; actor_it != NULL; actor_it = actor_it->next) {
			MetaWindowActor* actor = NULL;
			actor = (MetaWindowActor*) actor_it->data;
			{
				MetaWindowActor* _tmp40_;
				MetaWindow* window = NULL;
				MetaWindowActor* _tmp41_;
				MetaWindow* _tmp42_;
				MetaWindowType type = 0;
				MetaWindow* _tmp43_;
				MetaWindowType _tmp44_;
				MetaWindowType _tmp45_;
				gboolean _tmp46_ = FALSE;
				gboolean _tmp47_ = FALSE;
				MetaWindowType _tmp48_;
				gboolean _tmp52_ = FALSE;
				MetaWindow* _tmp53_;
				const gchar* _tmp54_;
				const gchar* _tmp55_;
				GalaBehaviorSettings* _tmp56_;
				gchar** _tmp57_;
				gint _tmp57__length1;
				gchar** _tmp58_;
				gint _tmp58__length1;
				_tmp40_ = actor;
				if (meta_window_actor_is_destroyed (_tmp40_)) {
					continue;
				}
				_tmp41_ = actor;
				_tmp42_ = meta_window_actor_get_meta_window (_tmp41_);
				window = _tmp42_;
				_tmp43_ = window;
				_tmp44_ = meta_window_get_window_type (_tmp43_);
				_tmp45_ = _tmp44_;
				type = _tmp45_;
				_tmp48_ = type;
				if (_tmp48_ != META_WINDOW_DOCK) {
					MetaWindowType _tmp49_;
					_tmp49_ = type;
					_tmp47_ = _tmp49_ != META_WINDOW_DESKTOP;
				} else {
					_tmp47_ = FALSE;
				}
				if (_tmp47_) {
					MetaWindowType _tmp50_;
					_tmp50_ = type;
					_tmp46_ = _tmp50_ != META_WINDOW_NOTIFICATION;
				} else {
					_tmp46_ = FALSE;
				}
				if (_tmp46_) {
					MetaWindowActor* _tmp51_;
					_tmp51_ = actor;
					clutter_actor_hide ((ClutterActor*) _tmp51_);
				}
				_tmp53_ = window;
				_tmp54_ = meta_window_get_title (_tmp53_);
				_tmp55_ = _tmp54_;
				_tmp56_ = gala_behavior_settings_get_default ();
				_tmp57_ = gala_behavior_settings_get_dock_names (_tmp56_, &_tmp57__length1);
				_tmp58_ = _tmp57_;
				_tmp58__length1 = _tmp57__length1;
				if (_vala_string_array_contains (_tmp58_, _tmp58__length1, _tmp55_)) {
					MetaWindowType _tmp59_;
					_tmp59_ = type;
					_tmp52_ = _tmp59_ == META_WINDOW_DOCK;
				} else {
					_tmp52_ = FALSE;
				}
				if (_tmp52_) {
					MetaWindowActor* _tmp60_;
					MetaWindowActor* _tmp61_;
					MetaWindowActor* _tmp62_;
					_tmp60_ = actor;
					_tmp61_ = _g_object_ref0 (_tmp60_);
					_g_object_unref0 (self->priv->dock_window);
					self->priv->dock_window = _tmp61_;
					_tmp62_ = self->priv->dock_window;
					clutter_actor_hide ((ClutterActor*) _tmp62_);
				}
			}
		}
	}
	result = TRUE;
	_g_object_unref0 (current);
	(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
	_g_object_unref0 (display);
	_g_object_unref0 (screen);
	return result;
}

static GalaWindowIcon*
gala_window_switcher_next_window (GalaWindowSwitcher* self,
                                  MetaWorkspace* workspace,
                                  gboolean backward)
{
	ClutterActor* actor = NULL;
	ClutterActor* _tmp14_;
	GalaWindowIcon* _tmp15_;
	GalaWindowIcon* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (workspace != NULL, NULL);
	if (!backward) {
		GalaWindowIcon* _tmp0_;
		ClutterActor* _tmp1_;
		ClutterActor* _tmp2_;
		ClutterActor* _tmp3_;
		_tmp0_ = self->priv->current_window;
		_tmp1_ = clutter_actor_get_next_sibling ((ClutterActor*) _tmp0_);
		_tmp2_ = _g_object_ref0 (_tmp1_);
		_g_object_unref0 (actor);
		actor = _tmp2_;
		_tmp3_ = actor;
		if (_tmp3_ == NULL) {
			ClutterActor* _tmp4_;
			ClutterActor* _tmp5_;
			ClutterActor* _tmp6_;
			_tmp4_ = self->priv->dock;
			_tmp5_ = clutter_actor_get_first_child (_tmp4_);
			_tmp6_ = _g_object_ref0 (_tmp5_);
			_g_object_unref0 (actor);
			actor = _tmp6_;
		}
	} else {
		GalaWindowIcon* _tmp7_;
		ClutterActor* _tmp8_;
		ClutterActor* _tmp9_;
		ClutterActor* _tmp10_;
		_tmp7_ = self->priv->current_window;
		_tmp8_ = clutter_actor_get_previous_sibling ((ClutterActor*) _tmp7_);
		_tmp9_ = _g_object_ref0 (_tmp8_);
		_g_object_unref0 (actor);
		actor = _tmp9_;
		_tmp10_ = actor;
		if (_tmp10_ == NULL) {
			ClutterActor* _tmp11_;
			ClutterActor* _tmp12_;
			ClutterActor* _tmp13_;
			_tmp11_ = self->priv->dock;
			_tmp12_ = clutter_actor_get_last_child (_tmp11_);
			_tmp13_ = _g_object_ref0 (_tmp12_);
			_g_object_unref0 (actor);
			actor = _tmp13_;
		}
	}
	_tmp14_ = actor;
	_tmp15_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, GALA_TYPE_WINDOW_ICON, GalaWindowIcon));
	result = _tmp15_;
	_g_object_unref0 (actor);
	return result;
}

/**
         * copied from gnome-shell, finds the primary modifier in the mask and saves it
         * to our modifier_mask field
         *
         * @param mask The modifier mask to extract the primary one from
         */
static void
gala_window_switcher_set_primary_modifier (GalaWindowSwitcher* self,
                                           guint mask)
{
	g_return_if_fail (self != NULL);
	if (mask == ((guint) 0)) {
		self->priv->modifier_mask = (guint) 0;
	} else {
		self->priv->modifier_mask = (guint) 1;
		while (TRUE) {
			if (!(mask > ((guint) 1))) {
				break;
			}
			mask = mask >> 1;
			self->priv->modifier_mask = self->priv->modifier_mask << 1;
		}
	}
}

/**
         * Counts the launcher items to get an estimate of the window size
         */
static void
gala_window_switcher_update_n_dock_items (GalaWindowSwitcher* self,
                                          GFile* folder,
                                          GFile* other_file,
                                          GFileMonitorEvent event)
{
	gboolean _tmp0_ = FALSE;
	gint count = 0;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (folder != NULL);
	if (event != G_FILE_MONITOR_EVENT_CREATED) {
		_tmp0_ = event != G_FILE_MONITOR_EVENT_DELETED;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		return;
	}
	count = 0;
	{
		GFileEnumerator* children = NULL;
		GFileEnumerator* _tmp1_;
		_tmp1_ = g_file_enumerate_children (folder, "", 0, NULL, &_inner_error0_);
		children = _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch26_g_error;
		}
		while (TRUE) {
			GFileInfo* _tmp2_ = NULL;
			GFileEnumerator* _tmp3_;
			GFileInfo* _tmp4_;
			gint _tmp5_;
			_tmp3_ = children;
			_tmp4_ = g_file_enumerator_next_file (_tmp3_, NULL, &_inner_error0_);
			_tmp2_ = _tmp4_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (children);
				goto __catch26_g_error;
			}
			if (!(_tmp2_ != NULL)) {
				_g_object_unref0 (_tmp2_);
				break;
			}
			_tmp5_ = count;
			count = _tmp5_ + 1;
			_g_object_unref0 (_tmp2_);
		}
		_g_object_unref0 (children);
	}
	goto __finally26;
	__catch26_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp6_ = e;
		_tmp7_ = _tmp6_->message;
		g_warning ("WindowSwitcher.vala:773: %s", _tmp7_);
		_g_error_free0 (e);
	}
	__finally26:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	self->priv->n_dock_items = count;
}

static GdkModifierType
gala_window_switcher_get_current_modifiers (GalaWindowSwitcher* self)
{
	GdkModifierType modifiers = 0U;
	gdouble* axes = NULL;
	gdouble* _tmp0_;
	gint axes_length1;
	gint _axes_size_;
	GdkDisplay* _tmp1_;
	GdkDeviceManager* _tmp2_;
	GdkDevice* _tmp3_;
	GdkWindow* _tmp4_;
	GdkModifierType _tmp5_ = 0U;
	GdkModifierType result = 0U;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = g_new0 (gdouble, 0);
	axes = _tmp0_;
	axes_length1 = 0;
	_axes_size_ = axes_length1;
	_tmp1_ = gdk_display_get_default ();
	_tmp2_ = gdk_display_get_device_manager (_tmp1_);
	_tmp3_ = gdk_device_manager_get_client_pointer (_tmp2_);
	_tmp4_ = gdk_get_default_root_window ();
	gdk_device_get_state (_tmp3_, _tmp4_, axes, &_tmp5_);
	modifiers = _tmp5_;
	result = modifiers;
	axes = (g_free (axes), NULL);
	return result;
}

GalaWindowManager*
gala_window_switcher_get_wm (GalaWindowSwitcher* self)
{
	GalaWindowManager* result;
	GalaWindowManager* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_wm;
	result = _tmp0_;
	return result;
}

static void
gala_window_switcher_set_wm (GalaWindowSwitcher* self,
                             GalaWindowManager* value)
{
	g_return_if_fail (self != NULL);
	if (gala_window_switcher_get_wm (self) != value) {
		GalaWindowManager* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_wm);
		self->priv->_wm = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gala_window_switcher_properties[GALA_WINDOW_SWITCHER_WM_PROPERTY]);
	}
}

static Block45Data*
block45_data_ref (Block45Data* _data45_)
{
	g_atomic_int_inc (&_data45_->_ref_count_);
	return _data45_;
}

static void
block45_data_unref (void * _userdata_)
{
	Block45Data* _data45_;
	_data45_ = (Block45Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data45_->_ref_count_)) {
		GalaWindowSwitcher* self;
		self = _data45_->self;
		_g_object_unref0 (_data45_->dock_canvas);
		_g_object_unref0 (self);
		g_slice_free (Block45Data, _data45_);
	}
}

static void
_gala_window_switcher_load_dock_theme_g_object_notify (GObject* _sender,
                                                       GParamSpec* pspec,
                                                       gpointer self)
{
	gala_window_switcher_load_dock_theme ((GalaWindowSwitcher*) self);
}

static void
_gala_window_switcher_update_n_dock_items_g_file_monitor_changed (GFileMonitor* _sender,
                                                                  GFile* file,
                                                                  GFile* other_file,
                                                                  GFileMonitorEvent event_type,
                                                                  gpointer self)
{
	gala_window_switcher_update_n_dock_items ((GalaWindowSwitcher*) self, file, other_file, event_type);
}

static gboolean
_gala_window_switcher_draw_dock_background_clutter_canvas_draw (ClutterCanvas* _sender,
                                                                cairo_t* cr,
                                                                gint width,
                                                                gint height,
                                                                gpointer self)
{
	gboolean result;
	result = gala_window_switcher_draw_dock_background ((GalaWindowSwitcher*) self, cr);
	return result;
}

static void
_gala_window_switcher_icon_removed_clutter_container_actor_removed (ClutterContainer* _sender,
                                                                    ClutterActor* actor,
                                                                    gpointer self)
{
	gala_window_switcher_icon_removed ((GalaWindowSwitcher*) self, actor);
}

static void
_gala_window_switcher___lambda48_ (Block45Data* _data45_)
{
	GalaWindowSwitcher* self;
	ClutterCanvas* _tmp0_;
	ClutterActor* _tmp1_;
	gfloat _tmp2_;
	gfloat _tmp3_;
	ClutterActor* _tmp4_;
	gfloat _tmp5_;
	gfloat _tmp6_;
	self = _data45_->self;
	_tmp0_ = _data45_->dock_canvas;
	_tmp1_ = self->priv->dock;
	_tmp2_ = clutter_actor_get_width (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = self->priv->dock;
	_tmp5_ = clutter_actor_get_height (_tmp4_);
	_tmp6_ = _tmp5_;
	clutter_canvas_set_size (_tmp0_, (gint) _tmp3_, (gint) _tmp6_);
}

static void
__gala_window_switcher___lambda48__g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self)
{
	_gala_window_switcher___lambda48_ (self);
}

static void
_gala_window_switcher_window_removed_clutter_container_actor_removed (ClutterContainer* _sender,
                                                                      ClutterActor* actor,
                                                                      gpointer self)
{
	gala_window_switcher_window_removed ((GalaWindowSwitcher*) self, actor);
}

static GObject *
gala_window_switcher_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaWindowSwitcher * self;
	Block45Data* _data45_;
	PlankDockPreferences* _tmp0_;
	PlankDockPreferences* _tmp1_;
	PlankDockPreferences* _tmp2_;
	GFile* launcher_folder = NULL;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GFile* _tmp6_;
	GFile* _tmp7_;
	GFile* _tmp8_;
	GFile* _tmp9_;
	ClutterActor* _tmp18_;
	ClutterActor* _tmp19_;
	ClutterBoxLayout* _tmp20_;
	ClutterBoxLayout* _tmp21_;
	ClutterCanvas* _tmp22_;
	ClutterCanvas* _tmp23_;
	ClutterActor* _tmp24_;
	ClutterCanvas* _tmp25_;
	ClutterActor* _tmp26_;
	ClutterActor* _tmp27_;
	ClutterActor* _tmp28_;
	ClutterActor* _tmp29_;
	ClutterActor* _tmp30_;
	ClutterActor* _tmp31_;
	ClutterActor* _tmp32_;
	ClutterActor* _tmp33_;
	ClutterActor* _tmp34_;
	GalaWindowManager* _tmp35_;
	MetaScreen* _tmp36_;
	GError* _inner_error0_ = NULL;
	parent_class = G_OBJECT_CLASS (gala_window_switcher_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcher);
	_data45_ = g_slice_new0 (Block45Data);
	_data45_->_ref_count_ = 1;
	_data45_->self = g_object_ref (self);
	_tmp0_ = plank_dock_preferences_new ("dock1");
	_g_object_unref0 (self->priv->dock_settings);
	self->priv->dock_settings = _tmp0_;
	_tmp1_ = self->priv->dock_settings;
	g_signal_connect_object ((GObject*) _tmp1_, "notify", (GCallback) _gala_window_switcher_update_dock_g_object_notify, self, 0);
	_tmp2_ = self->priv->dock_settings;
	g_signal_connect_object ((GObject*) _tmp2_, "notify::Theme", (GCallback) _gala_window_switcher_load_dock_theme_g_object_notify, self, 0);
	_tmp3_ = plank_paths_get_AppConfigFolder ();
	_tmp4_ = _tmp3_;
	_tmp5_ = g_file_get_child (_tmp4_, "dock1");
	_tmp6_ = _tmp5_;
	_tmp7_ = g_file_get_child (_tmp6_, "launchers");
	_tmp8_ = _tmp7_;
	_g_object_unref0 (_tmp6_);
	launcher_folder = _tmp8_;
	_tmp9_ = launcher_folder;
	if (g_file_query_exists (_tmp9_, NULL)) {
		GFile* _tmp17_;
		{
			GFileMonitor* _tmp10_ = NULL;
			GFile* _tmp11_;
			GFileMonitor* _tmp12_;
			GFileMonitor* _tmp13_;
			GFileMonitor* _tmp14_;
			_tmp11_ = launcher_folder;
			_tmp12_ = g_file_monitor (_tmp11_, G_FILE_MONITOR_NONE, NULL, &_inner_error0_);
			_tmp10_ = _tmp12_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch27_g_error;
			}
			_tmp13_ = _tmp10_;
			_tmp10_ = NULL;
			_g_object_unref0 (self->priv->monitor);
			self->priv->monitor = _tmp13_;
			_tmp14_ = self->priv->monitor;
			g_signal_connect_object (_tmp14_, "changed", (GCallback) _gala_window_switcher_update_n_dock_items_g_file_monitor_changed, self, 0);
			_g_object_unref0 (_tmp10_);
		}
		goto __finally27;
		__catch27_g_error:
		{
			GError* e = NULL;
			GError* _tmp15_;
			const gchar* _tmp16_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp15_ = e;
			_tmp16_ = _tmp15_->message;
			g_warning ("WindowSwitcher.vala:71: %s", _tmp16_);
			_g_error_free0 (e);
		}
		__finally27:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (launcher_folder);
			block45_data_unref (_data45_);
			_data45_ = NULL;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
		}
		_tmp17_ = launcher_folder;
		gala_window_switcher_update_n_dock_items (self, _tmp17_, NULL, G_FILE_MONITOR_EVENT_CREATED);
	}
	self->priv->ui_scale_factor = gala_internal_utils_get_ui_scaling_factor ();
	_tmp18_ = clutter_actor_new ();
	g_object_ref_sink (_tmp18_);
	_g_object_unref0 (self->priv->dock);
	self->priv->dock = _tmp18_;
	_tmp19_ = self->priv->dock;
	_tmp20_ = (ClutterBoxLayout*) clutter_box_layout_new ();
	g_object_ref_sink (_tmp20_);
	_tmp21_ = _tmp20_;
	clutter_actor_set_layout_manager (_tmp19_, (ClutterLayoutManager*) _tmp21_);
	_g_object_unref0 (_tmp21_);
	_tmp22_ = (ClutterCanvas*) clutter_canvas_new ();
	_data45_->dock_canvas = _tmp22_;
	_tmp23_ = _data45_->dock_canvas;
	g_signal_connect_object (_tmp23_, "draw", (GCallback) _gala_window_switcher_draw_dock_background_clutter_canvas_draw, self, 0);
	_tmp24_ = self->priv->dock;
	_tmp25_ = _data45_->dock_canvas;
	clutter_actor_set_content (_tmp24_, (ClutterContent*) _tmp25_);
	_tmp26_ = self->priv->dock;
	g_signal_connect_object ((ClutterContainer*) _tmp26_, "actor-removed", (GCallback) _gala_window_switcher_icon_removed_clutter_container_actor_removed, self, 0);
	_tmp27_ = self->priv->dock;
	g_signal_connect_data ((GObject*) _tmp27_, "notify::allocation", (GCallback) __gala_window_switcher___lambda48__g_object_notify, block45_data_ref (_data45_), (GClosureNotify) block45_data_unref, 0);
	gala_window_switcher_load_dock_theme (self);
	_tmp28_ = clutter_actor_new ();
	g_object_ref_sink (_tmp28_);
	_g_object_unref0 (self->priv->window_clones);
	self->priv->window_clones = _tmp28_;
	_tmp29_ = self->priv->window_clones;
	g_signal_connect_object ((ClutterContainer*) _tmp29_, "actor-removed", (GCallback) _gala_window_switcher_window_removed_clutter_container_actor_removed, self, 0);
	_tmp30_ = clutter_actor_new ();
	g_object_ref_sink (_tmp30_);
	_g_object_unref0 (self->priv->background);
	self->priv->background = _tmp30_;
	_tmp31_ = self->priv->background;
	clutter_actor_set_background_color (_tmp31_, clutter_color_get_static (CLUTTER_COLOR_BLACK));
	gala_window_switcher_update_background (self);
	_tmp32_ = self->priv->background;
	clutter_actor_add_child ((ClutterActor*) self, _tmp32_);
	_tmp33_ = self->priv->window_clones;
	clutter_actor_add_child ((ClutterActor*) self, _tmp33_);
	_tmp34_ = self->priv->dock;
	clutter_actor_add_child ((ClutterActor*) self, _tmp34_);
	_tmp35_ = self->priv->_wm;
	_tmp36_ = meta_plugin_get_screen ((MetaPlugin*) _tmp35_);
	g_signal_connect_object (_tmp36_, "monitors-changed", (GCallback) _gala_window_switcher_update_actors_meta_screen_monitors_changed, self, 0);
	g_object_set ((ClutterActor*) self, "visible", FALSE, NULL);
	_g_object_unref0 (launcher_folder);
	return obj;
}

static void
gala_window_switcher_class_init (GalaWindowSwitcherClass * klass,
                                 gpointer klass_data)
{
	gala_window_switcher_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &GalaWindowSwitcher_private_offset);
	((ClutterActorClass *) klass)->key_release_event = (gboolean (*) (ClutterActor*, ClutterKeyEvent*)) gala_window_switcher_real_key_release_event;
	((ClutterActorClass *) klass)->key_focus_out = (void (*) (ClutterActor*)) gala_window_switcher_real_key_focus_out;
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_window_switcher_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_window_switcher_set_property;
	G_OBJECT_CLASS (klass)->constructor = gala_window_switcher_constructor;
	G_OBJECT_CLASS (klass)->finalize = gala_window_switcher_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_SWITCHER_WM_PROPERTY, gala_window_switcher_properties[GALA_WINDOW_SWITCHER_WM_PROPERTY] = g_param_spec_object ("wm", "wm", "wm", GALA_TYPE_WINDOW_MANAGER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}

static void
gala_window_switcher_instance_init (GalaWindowSwitcher * self,
                                    gpointer klass)
{
	self->priv = gala_window_switcher_get_instance_private (self);
	self->priv->current_window = NULL;
	self->priv->ui_scale_factor = 1;
	self->priv->last_switch = (gint64) 0;
	self->priv->closing = FALSE;
	self->priv->dock_width = 0.0f;
	self->priv->n_dock_items = 0;
}

static void
gala_window_switcher_finalize (GObject * obj)
{
	GalaWindowSwitcher * self;
	GFileMonitor* _tmp0_;
	GalaWindowManager* _tmp2_;
	MetaScreen* _tmp3_;
	guint _tmp4_;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcher);
	_tmp0_ = self->priv->monitor;
	if (_tmp0_ != NULL) {
		GFileMonitor* _tmp1_;
		_tmp1_ = self->priv->monitor;
		g_file_monitor_cancel (_tmp1_);
	}
	_tmp2_ = self->priv->_wm;
	_tmp3_ = meta_plugin_get_screen ((MetaPlugin*) _tmp2_);
	g_signal_parse_name ("monitors-changed", meta_screen_get_type (), &_tmp4_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp3_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _gala_window_switcher_update_actors_meta_screen_monitors_changed, self);
	_g_object_unref0 (self->priv->_wm);
	_g_object_unref0 (self->priv->current_window);
	_g_object_unref0 (self->priv->window_clones);
	(self->priv->clone_sort_order == NULL) ? NULL : (self->priv->clone_sort_order = (g_list_free (self->priv->clone_sort_order), NULL));
	_g_object_unref0 (self->priv->dock_window);
	_g_object_unref0 (self->priv->dock);
	_g_object_unref0 (self->priv->dock_surface);
	_g_object_unref0 (self->priv->dock_theme);
	_g_object_unref0 (self->priv->dock_settings);
	_g_object_unref0 (self->priv->monitor);
	_g_object_unref0 (self->priv->background);
	_g_object_unref0 (self->priv->modal_proxy);
	G_OBJECT_CLASS (gala_window_switcher_parent_class)->finalize (obj);
}

GType
gala_window_switcher_get_type (void)
{
	static volatile gsize gala_window_switcher_type_id__volatile = 0;
	if (g_once_init_enter (&gala_window_switcher_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GalaWindowSwitcherClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_window_switcher_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaWindowSwitcher), 0, (GInstanceInitFunc) gala_window_switcher_instance_init, NULL };
		GType gala_window_switcher_type_id;
		gala_window_switcher_type_id = g_type_register_static (clutter_actor_get_type (), "GalaWindowSwitcher", &g_define_type_info, 0);
		GalaWindowSwitcher_private_offset = g_type_add_instance_private (gala_window_switcher_type_id, sizeof (GalaWindowSwitcherPrivate));
		g_once_init_leave (&gala_window_switcher_type_id__volatile, gala_window_switcher_type_id);
	}
	return gala_window_switcher_type_id__volatile;
}

static void
_vala_gala_window_switcher_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	GalaWindowSwitcher * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcher);
	switch (property_id) {
		case GALA_WINDOW_SWITCHER_WM_PROPERTY:
		g_value_set_object (value, gala_window_switcher_get_wm (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_gala_window_switcher_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	GalaWindowSwitcher * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcher);
	switch (property_id) {
		case GALA_WINDOW_SWITCHER_WM_PROPERTY:
		gala_window_switcher_set_wm (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

