/* WorkspaceManager.c generated by valac 0.44.11, the Vala compiler
 * generated from WorkspaceManager.vala, do not modify */

/**/
/*  Copyright (C) 2014 Tom Beckmann, Rico Tzschichholz*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib-object.h>
#include "gala.h"
#include <gee.h>
#include <meta/workspace.h>
#include <glib.h>
#include <meta/prefs.h>
#include <meta/screen.h>
#include <meta/meta-plugin.h>
#include <meta/common.h>
#include <meta/window.h>
#include <meta/display.h>

#define GALA_TYPE_WORKSPACE_MANAGER (gala_workspace_manager_get_type ())
#define GALA_WORKSPACE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManager))
#define GALA_WORKSPACE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManagerClass))
#define GALA_IS_WORKSPACE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WORKSPACE_MANAGER))
#define GALA_IS_WORKSPACE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WORKSPACE_MANAGER))
#define GALA_WORKSPACE_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManagerClass))

typedef struct _GalaWorkspaceManager GalaWorkspaceManager;
typedef struct _GalaWorkspaceManagerClass GalaWorkspaceManagerClass;
typedef struct _GalaWorkspaceManagerPrivate GalaWorkspaceManagerPrivate;
enum  {
	GALA_WORKSPACE_MANAGER_0_PROPERTY,
	GALA_WORKSPACE_MANAGER_WM_PROPERTY,
	GALA_WORKSPACE_MANAGER_NUM_PROPERTIES
};
static GParamSpec* gala_workspace_manager_properties[GALA_WORKSPACE_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _GalaWorkspaceManager {
	GObject parent_instance;
	GalaWorkspaceManagerPrivate * priv;
};

struct _GalaWorkspaceManagerClass {
	GObjectClass parent_class;
};

struct _GalaWorkspaceManagerPrivate {
	GalaWindowManager* _wm;
	GeeLinkedList* workspaces_marked_removed;
	gint remove_freeze_count;
};

static gint GalaWorkspaceManager_private_offset;
static gpointer gala_workspace_manager_parent_class = NULL;
static GalaWorkspaceManager* gala_workspace_manager_instance;
static GalaWorkspaceManager* gala_workspace_manager_instance = NULL;

GType gala_workspace_manager_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWorkspaceManager, g_object_unref)
static void gala_workspace_manager_prefs_listener (GalaWorkspaceManager* self,
                                            MetaPreference pref);
static void _gala_workspace_manager_prefs_listener_meta_prefs_changed_func (MetaPreference pref,
                                                                     gpointer self);
GalaWindowManager* gala_workspace_manager_get_wm (GalaWorkspaceManager* self);
static void gala_workspace_manager_workspace_added (GalaWorkspaceManager* self,
                                             MetaScreen* screen,
                                             gint index);
static void _gala_workspace_manager_workspace_added_meta_screen_workspace_added (MetaScreen* _sender,
                                                                          gint object,
                                                                          gpointer self);
static void gala_workspace_manager_workspace_switched (GalaWorkspaceManager* self,
                                                MetaScreen* screen,
                                                gint from,
                                                gint to,
                                                MetaMotionDirection direction);
static void _gala_workspace_manager_workspace_switched_meta_screen_workspace_switched (MetaScreen* _sender,
                                                                                gint object,
                                                                                gint p0,
                                                                                MetaMotionDirection p1,
                                                                                gpointer self);
static void gala_workspace_manager_workspace_removed (GalaWorkspaceManager* self,
                                               MetaScreen* screen,
                                               gint index);
static void _gala_workspace_manager_workspace_removed_meta_screen_workspace_removed (MetaScreen* _sender,
                                                                              gint object,
                                                                              gpointer self);
static void gala_workspace_manager_window_entered_monitor (GalaWorkspaceManager* self,
                                                    MetaScreen* screen,
                                                    gint monitor,
                                                    MetaWindow* window);
static void _gala_workspace_manager_window_entered_monitor_meta_screen_window_entered_monitor (MetaScreen* _sender,
                                                                                        gint object,
                                                                                        MetaWindow* p0,
                                                                                        gpointer self);
static void gala_workspace_manager_window_left_monitor (GalaWorkspaceManager* self,
                                                 MetaScreen* screen,
                                                 gint monitor,
                                                 MetaWindow* window);
static void _gala_workspace_manager_window_left_monitor_meta_screen_window_left_monitor (MetaScreen* _sender,
                                                                                  gint object,
                                                                                  MetaWindow* p0,
                                                                                  gpointer self);
void gala_workspace_manager_init (GalaWindowManager* wm);
static GalaWorkspaceManager* gala_workspace_manager_new (GalaWindowManager* wm);
static GalaWorkspaceManager* gala_workspace_manager_construct (GType object_type,
                                                        GalaWindowManager* wm);
GalaWorkspaceManager* gala_workspace_manager_get_default (void);
static void gala_workspace_manager_window_added (GalaWorkspaceManager* self,
                                          MetaWorkspace* workspace,
                                          MetaWindow* window);
static void _gala_workspace_manager_window_added_meta_workspace_window_added (MetaWorkspace* _sender,
                                                                       MetaWindow* object,
                                                                       gpointer self);
static void gala_workspace_manager_window_removed (GalaWorkspaceManager* self,
                                            MetaWorkspace* workspace,
                                            MetaWindow* window);
static void _gala_workspace_manager_window_removed_meta_workspace_window_removed (MetaWorkspace* _sender,
                                                                           MetaWindow* object,
                                                                           gpointer self);
static void gala_workspace_manager_remove_workspace (GalaWorkspaceManager* self,
                                              MetaWorkspace* workspace);
static void gala_workspace_manager_append_workspace (GalaWorkspaceManager* self);
gboolean gala_internal_utils_workspaces_only_on_primary (void);
void gala_workspace_manager_freeze_remove (GalaWorkspaceManager* self);
void gala_workspace_manager_thaw_remove (GalaWorkspaceManager* self);
void gala_workspace_manager_cleanup (GalaWorkspaceManager* self);
static void gala_workspace_manager_set_wm (GalaWorkspaceManager* self,
                                    GalaWindowManager* value);
static GObject * gala_workspace_manager_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
static void gala_workspace_manager_finalize (GObject * obj);
static void _vala_gala_workspace_manager_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_gala_workspace_manager_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);

static inline gpointer
gala_workspace_manager_get_instance_private (GalaWorkspaceManager* self)
{
	return G_STRUCT_MEMBER_P (self, GalaWorkspaceManager_private_offset);
}

static void
_gala_workspace_manager_prefs_listener_meta_prefs_changed_func (MetaPreference pref,
                                                                gpointer self)
{
	gala_workspace_manager_prefs_listener ((GalaWorkspaceManager*) self, pref);
}

static void
_gala_workspace_manager_workspace_added_meta_screen_workspace_added (MetaScreen* _sender,
                                                                     gint object,
                                                                     gpointer self)
{
	gala_workspace_manager_workspace_added ((GalaWorkspaceManager*) self, _sender, object);
}

static void
_gala_workspace_manager_workspace_switched_meta_screen_workspace_switched (MetaScreen* _sender,
                                                                           gint object,
                                                                           gint p0,
                                                                           MetaMotionDirection p1,
                                                                           gpointer self)
{
	gala_workspace_manager_workspace_switched ((GalaWorkspaceManager*) self, _sender, object, p0, p1);
}

static void
_gala_workspace_manager_workspace_removed_meta_screen_workspace_removed (MetaScreen* _sender,
                                                                         gint object,
                                                                         gpointer self)
{
	gala_workspace_manager_workspace_removed ((GalaWorkspaceManager*) self, _sender, object);
}

static void
_gala_workspace_manager_window_entered_monitor_meta_screen_window_entered_monitor (MetaScreen* _sender,
                                                                                   gint object,
                                                                                   MetaWindow* p0,
                                                                                   gpointer self)
{
	gala_workspace_manager_window_entered_monitor ((GalaWorkspaceManager*) self, _sender, object, p0);
}

static void
_gala_workspace_manager_window_left_monitor_meta_screen_window_left_monitor (MetaScreen* _sender,
                                                                             gint object,
                                                                             MetaWindow* p0,
                                                                             gpointer self)
{
	gala_workspace_manager_window_left_monitor ((GalaWorkspaceManager*) self, _sender, object, p0);
}

void
gala_workspace_manager_init (GalaWindowManager* wm)
{
	GalaWorkspaceManager* _tmp0_;
	GalaWorkspaceManager* _tmp1_;
	g_return_if_fail (wm != NULL);
	_tmp0_ = gala_workspace_manager_instance;
	_vala_return_if_fail (_tmp0_ == NULL, "instance == null");
	_tmp1_ = gala_workspace_manager_new (wm);
	_g_object_unref0 (gala_workspace_manager_instance);
	gala_workspace_manager_instance = _tmp1_;
}

GalaWorkspaceManager*
gala_workspace_manager_get_default (void)
{
	GalaWorkspaceManager* _tmp0_;
	GalaWorkspaceManager* _tmp1_;
	GalaWorkspaceManager* result = NULL;
	_tmp0_ = gala_workspace_manager_instance;
	_vala_return_val_if_fail (_tmp0_ != NULL, "instance != null", NULL);
	_tmp1_ = gala_workspace_manager_instance;
	result = _tmp1_;
	return result;
}

static GalaWorkspaceManager*
gala_workspace_manager_construct (GType object_type,
                                  GalaWindowManager* wm)
{
	GalaWorkspaceManager * self = NULL;
	g_return_val_if_fail (wm != NULL, NULL);
	self = (GalaWorkspaceManager*) g_object_new (object_type, "wm", wm, NULL);
	return self;
}

static GalaWorkspaceManager*
gala_workspace_manager_new (GalaWindowManager* wm)
{
	return gala_workspace_manager_construct (GALA_TYPE_WORKSPACE_MANAGER, wm);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_gala_workspace_manager_window_added_meta_workspace_window_added (MetaWorkspace* _sender,
                                                                  MetaWindow* object,
                                                                  gpointer self)
{
	gala_workspace_manager_window_added ((GalaWorkspaceManager*) self, _sender, object);
}

static void
_gala_workspace_manager_window_removed_meta_workspace_window_removed (MetaWorkspace* _sender,
                                                                      MetaWindow* object,
                                                                      gpointer self)
{
	gala_workspace_manager_window_removed ((GalaWorkspaceManager*) self, _sender, object);
}

static void
gala_workspace_manager_workspace_added (GalaWorkspaceManager* self,
                                        MetaScreen* screen,
                                        gint index)
{
	MetaWorkspace* workspace = NULL;
	MetaWorkspace* _tmp0_;
	MetaWorkspace* _tmp1_;
	MetaWorkspace* _tmp2_;
	MetaWorkspace* _tmp3_;
	MetaWorkspace* _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (screen != NULL);
	_tmp0_ = meta_screen_get_workspace_by_index (screen, index);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	workspace = _tmp1_;
	_tmp2_ = workspace;
	if (_tmp2_ == NULL) {
		_g_object_unref0 (workspace);
		return;
	}
	_tmp3_ = workspace;
	g_signal_connect_object (_tmp3_, "window-added", (GCallback) _gala_workspace_manager_window_added_meta_workspace_window_added, self, 0);
	_tmp4_ = workspace;
	g_signal_connect_object (_tmp4_, "window-removed", (GCallback) _gala_workspace_manager_window_removed_meta_workspace_window_removed, self, 0);
	_g_object_unref0 (workspace);
}

static void
gala_workspace_manager_workspace_removed (GalaWorkspaceManager* self,
                                          MetaScreen* screen,
                                          gint index)
{
	GList* existing_workspaces = NULL;
	GList* _tmp0_;
	GeeIterator* it = NULL;
	GeeLinkedList* _tmp1_;
	GeeIterator* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (screen != NULL);
	_tmp0_ = meta_screen_get_workspaces (screen);
	existing_workspaces = _tmp0_;
	_tmp1_ = self->priv->workspaces_marked_removed;
	_tmp2_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp1_);
	it = _tmp2_;
	while (TRUE) {
		GeeIterator* _tmp3_;
		GList* _tmp4_;
		GeeIterator* _tmp5_;
		gpointer _tmp6_;
		MetaWorkspace* _tmp7_;
		gboolean _tmp8_;
		_tmp3_ = it;
		if (!gee_iterator_next (_tmp3_)) {
			break;
		}
		_tmp4_ = existing_workspaces;
		_tmp5_ = it;
		_tmp6_ = gee_iterator_get (_tmp5_);
		_tmp7_ = (MetaWorkspace*) _tmp6_;
		_tmp8_ = g_list_index (_tmp4_, _tmp7_) < 0;
		_g_object_unref0 (_tmp7_);
		if (_tmp8_) {
			GeeIterator* _tmp9_;
			_tmp9_ = it;
			gee_iterator_remove (_tmp9_);
		}
	}
	_g_object_unref0 (it);
}

static void
gala_workspace_manager_workspace_switched (GalaWorkspaceManager* self,
                                           MetaScreen* screen,
                                           gint from,
                                           gint to,
                                           MetaMotionDirection direction)
{
	MetaWorkspace* prev_workspace = NULL;
	MetaWorkspace* _tmp0_;
	MetaWorkspace* _tmp1_;
	gboolean _tmp2_ = FALSE;
	MetaWorkspace* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (screen != NULL);
	if (!meta_prefs_get_dynamic_workspaces ()) {
		return;
	}
	_tmp0_ = meta_screen_get_workspace_by_index (screen, from);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	prev_workspace = _tmp1_;
	_tmp3_ = prev_workspace;
	if (gala_utils_get_n_windows (_tmp3_) < ((guint) 1)) {
		_tmp2_ = from != (meta_screen_get_n_workspaces (screen) - 1);
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		MetaWorkspace* _tmp4_;
		_tmp4_ = prev_workspace;
		gala_workspace_manager_remove_workspace (self, _tmp4_);
	}
	_g_object_unref0 (prev_workspace);
}

static void
gala_workspace_manager_window_added (GalaWorkspaceManager* self,
                                     MetaWorkspace* workspace,
                                     MetaWindow* window)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	MetaScreen* screen = NULL;
	MetaScreen* _tmp4_;
	gint last_workspace = 0;
	MetaScreen* _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	MetaWindowType _tmp9_;
	MetaWindowType _tmp10_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (window != NULL);
	if (workspace == NULL) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = !meta_prefs_get_dynamic_workspaces ();
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp2_;
		gboolean _tmp3_;
		g_object_get (window, "on-all-workspaces", &_tmp2_, NULL);
		_tmp3_ = _tmp2_;
		_tmp0_ = _tmp3_;
	}
	if (_tmp0_) {
		return;
	}
	_tmp4_ = meta_workspace_get_screen (workspace);
	screen = _tmp4_;
	_tmp5_ = screen;
	last_workspace = meta_screen_get_n_workspaces (_tmp5_) - 1;
	_tmp9_ = meta_window_get_window_type (window);
	_tmp10_ = _tmp9_;
	if (_tmp10_ == META_WINDOW_NORMAL) {
		_tmp8_ = TRUE;
	} else {
		MetaWindowType _tmp11_;
		MetaWindowType _tmp12_;
		_tmp11_ = meta_window_get_window_type (window);
		_tmp12_ = _tmp11_;
		_tmp8_ = _tmp12_ == META_WINDOW_DIALOG;
	}
	if (_tmp8_) {
		_tmp7_ = TRUE;
	} else {
		MetaWindowType _tmp13_;
		MetaWindowType _tmp14_;
		_tmp13_ = meta_window_get_window_type (window);
		_tmp14_ = _tmp13_;
		_tmp7_ = _tmp14_ == META_WINDOW_MODAL_DIALOG;
	}
	if (_tmp7_) {
		_tmp6_ = meta_workspace_index (workspace) == last_workspace;
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		gala_workspace_manager_append_workspace (self);
	}
}

static void
gala_workspace_manager_window_removed (GalaWorkspaceManager* self,
                                       MetaWorkspace* workspace,
                                       MetaWindow* window)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	MetaScreen* screen = NULL;
	MetaScreen* _tmp4_;
	gint index = 0;
	MetaScreen* _tmp5_;
	GList* _tmp6_;
	gboolean is_active_workspace = FALSE;
	MetaScreen* _tmp7_;
	MetaWorkspace* _tmp8_;
	gint last_workspace = 0;
	MetaScreen* _tmp9_;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	MetaWindowType _tmp12_;
	MetaWindowType _tmp13_;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_ = FALSE;
	gboolean _tmp21_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (window != NULL);
	if (workspace == NULL) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = !meta_prefs_get_dynamic_workspaces ();
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp2_;
		gboolean _tmp3_;
		g_object_get (window, "on-all-workspaces", &_tmp2_, NULL);
		_tmp3_ = _tmp2_;
		_tmp0_ = _tmp3_;
	}
	if (_tmp0_) {
		return;
	}
	_tmp4_ = meta_workspace_get_screen (workspace);
	screen = _tmp4_;
	_tmp5_ = screen;
	_tmp6_ = meta_screen_get_workspaces (_tmp5_);
	index = g_list_index (_tmp6_, workspace);
	_tmp7_ = screen;
	_tmp8_ = meta_screen_get_active_workspace (_tmp7_);
	is_active_workspace = workspace == _tmp8_;
	_tmp9_ = screen;
	last_workspace = meta_screen_get_n_workspaces (_tmp9_) - 1;
	_tmp12_ = meta_window_get_window_type (window);
	_tmp13_ = _tmp12_;
	if (_tmp13_ != META_WINDOW_NORMAL) {
		MetaWindowType _tmp14_;
		MetaWindowType _tmp15_;
		_tmp14_ = meta_window_get_window_type (window);
		_tmp15_ = _tmp14_;
		_tmp11_ = _tmp15_ != META_WINDOW_DIALOG;
	} else {
		_tmp11_ = FALSE;
	}
	if (_tmp11_) {
		MetaWindowType _tmp16_;
		MetaWindowType _tmp17_;
		_tmp16_ = meta_window_get_window_type (window);
		_tmp17_ = _tmp16_;
		_tmp10_ = _tmp17_ != META_WINDOW_MODAL_DIALOG;
	} else {
		_tmp10_ = FALSE;
	}
	if (_tmp10_) {
		return;
	}
	if (index < 0) {
		return;
	}
	if (!is_active_workspace) {
		_tmp21_ = TRUE;
	} else {
		GalaWindowManager* _tmp22_;
		_tmp22_ = self->priv->_wm;
		_tmp21_ = gala_window_manager_is_modal (_tmp22_);
	}
	if (_tmp21_) {
		_tmp20_ = self->priv->remove_freeze_count < 1;
	} else {
		_tmp20_ = FALSE;
	}
	if (_tmp20_) {
		_tmp19_ = gala_utils_get_n_windows (workspace) < ((guint) 1);
	} else {
		_tmp19_ = FALSE;
	}
	if (_tmp19_) {
		_tmp18_ = index != last_workspace;
	} else {
		_tmp18_ = FALSE;
	}
	if (_tmp18_) {
		gala_workspace_manager_remove_workspace (self, workspace);
	}
}

static void
gala_workspace_manager_window_entered_monitor (GalaWorkspaceManager* self,
                                               MetaScreen* screen,
                                               gint monitor,
                                               MetaWindow* window)
{
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (screen != NULL);
	g_return_if_fail (window != NULL);
	if (gala_internal_utils_workspaces_only_on_primary ()) {
		_tmp0_ = monitor == meta_screen_get_primary_monitor (screen);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		MetaWorkspace* _tmp1_;
		_tmp1_ = meta_window_get_workspace (window);
		gala_workspace_manager_window_added (self, _tmp1_, window);
	}
}

static void
gala_workspace_manager_window_left_monitor (GalaWorkspaceManager* self,
                                            MetaScreen* screen,
                                            gint monitor,
                                            MetaWindow* window)
{
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (screen != NULL);
	g_return_if_fail (window != NULL);
	if (gala_internal_utils_workspaces_only_on_primary ()) {
		_tmp0_ = monitor == meta_screen_get_primary_monitor (screen);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		MetaWorkspace* _tmp1_;
		_tmp1_ = meta_window_get_workspace (window);
		gala_workspace_manager_window_removed (self, _tmp1_, window);
	}
}

static void
gala_workspace_manager_prefs_listener (GalaWorkspaceManager* self,
                                       MetaPreference pref)
{
	MetaScreen* screen = NULL;
	GalaWindowManager* _tmp0_;
	MetaScreen* _tmp1_;
	gboolean _tmp2_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_wm;
	_tmp1_ = meta_plugin_get_screen ((MetaPlugin*) _tmp0_);
	screen = _tmp1_;
	if (pref == META_PREF_DYNAMIC_WORKSPACES) {
		_tmp2_ = meta_prefs_get_dynamic_workspaces ();
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		MetaScreen* _tmp3_;
		MetaScreen* _tmp4_;
		MetaWorkspace* _tmp5_;
		_tmp3_ = screen;
		_tmp4_ = screen;
		_tmp5_ = meta_screen_get_workspace_by_index (_tmp3_, meta_screen_get_n_workspaces (_tmp4_) - 1);
		if (gala_utils_get_n_windows (_tmp5_) > ((guint) 0)) {
			gala_workspace_manager_append_workspace (self);
		}
	}
}

static void
gala_workspace_manager_append_workspace (GalaWorkspaceManager* self)
{
	MetaScreen* screen = NULL;
	GalaWindowManager* _tmp0_;
	MetaScreen* _tmp1_;
	MetaDisplay* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_wm;
	_tmp1_ = meta_plugin_get_screen ((MetaPlugin*) _tmp0_);
	screen = _tmp1_;
	_tmp2_ = meta_screen_get_display (screen);
	meta_screen_append_new_workspace (screen, FALSE, meta_display_get_current_time (_tmp2_));
}

/**
         * Make sure we switch to a different workspace and remove the given one
         *
         * @param workspace The workspace to remove
         */
static void
gala_workspace_manager_remove_workspace (GalaWorkspaceManager* self,
                                         MetaWorkspace* workspace)
{
	MetaScreen* screen = NULL;
	MetaScreen* _tmp0_;
	guint32 time = 0U;
	MetaScreen* _tmp1_;
	MetaDisplay* _tmp2_;
	MetaWorkspace* active_workspace = NULL;
	MetaScreen* _tmp3_;
	MetaWorkspace* _tmp4_;
	MetaWorkspace* _tmp5_;
	GeeLinkedList* _tmp15_;
	guint _tmp16_;
	guint _tmp17_;
	GeeLinkedList* _tmp18_;
	MetaScreen* _tmp19_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (workspace != NULL);
	_tmp0_ = meta_workspace_get_screen (workspace);
	screen = _tmp0_;
	_tmp1_ = screen;
	_tmp2_ = meta_screen_get_display (_tmp1_);
	time = meta_display_get_current_time (_tmp2_);
	_tmp3_ = screen;
	_tmp4_ = meta_screen_get_active_workspace (_tmp3_);
	active_workspace = _tmp4_;
	_tmp5_ = active_workspace;
	if (workspace == _tmp5_) {
		MetaWorkspace* next = NULL;
		MetaWorkspace* _tmp6_;
		MetaWorkspace* _tmp7_;
		gboolean _tmp8_ = FALSE;
		MetaWorkspace* _tmp9_;
		MetaWorkspace* _tmp13_;
		next = NULL;
		_tmp6_ = meta_workspace_get_neighbor (workspace, META_MOTION_LEFT);
		_tmp7_ = _g_object_ref0 (_tmp6_);
		_g_object_unref0 (next);
		next = _tmp7_;
		_tmp9_ = next;
		if (_tmp9_ == workspace) {
			_tmp8_ = TRUE;
		} else {
			MetaWorkspace* _tmp10_;
			_tmp10_ = next;
			_tmp8_ = _tmp10_ == NULL;
		}
		if (_tmp8_) {
			MetaWorkspace* _tmp11_;
			MetaWorkspace* _tmp12_;
			_tmp11_ = meta_workspace_get_neighbor (workspace, META_MOTION_RIGHT);
			_tmp12_ = _g_object_ref0 (_tmp11_);
			_g_object_unref0 (next);
			next = _tmp12_;
		}
		_tmp13_ = next;
		if (_tmp13_ != NULL) {
			MetaWorkspace* _tmp14_;
			_tmp14_ = next;
			meta_workspace_activate (_tmp14_, time);
		}
		_g_object_unref0 (next);
	}
	_tmp15_ = self->priv->workspaces_marked_removed;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp15_, workspace)) {
		return;
	}
	g_signal_parse_name ("window-added", meta_workspace_get_type (), &_tmp16_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (workspace, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp16_, 0, NULL, (GCallback) _gala_workspace_manager_window_added_meta_workspace_window_added, self);
	g_signal_parse_name ("window-removed", meta_workspace_get_type (), &_tmp17_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (workspace, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp17_, 0, NULL, (GCallback) _gala_workspace_manager_window_removed_meta_workspace_window_removed, self);
	_tmp18_ = self->priv->workspaces_marked_removed;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp18_, workspace);
	_tmp19_ = screen;
	meta_screen_remove_workspace (_tmp19_, workspace, time);
}

/**
         * Temporarily disables removing workspaces when they are empty
         */
void
gala_workspace_manager_freeze_remove (GalaWorkspaceManager* self)
{
	gint _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->remove_freeze_count;
	self->priv->remove_freeze_count = _tmp0_ + 1;
}

/**
         * Undo the effect of freeze_remove()
         */
void
gala_workspace_manager_thaw_remove (GalaWorkspaceManager* self)
{
	gint _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->remove_freeze_count;
	self->priv->remove_freeze_count = _tmp0_ - 1;
	_vala_assert (self->priv->remove_freeze_count >= 0, "remove_freeze_count >= 0");
}

/**
         * If workspaces are dynamic, checks if there are empty workspaces that should
         * be removed. Particularily useful in conjunction with freeze/thaw_remove to
         * cleanup after an operation that required stable workspace/window indices
         */
void
gala_workspace_manager_cleanup (GalaWorkspaceManager* self)
{
	MetaScreen* screen = NULL;
	GalaWindowManager* _tmp0_;
	MetaScreen* _tmp1_;
	MetaScreen* _tmp2_;
	gint last_index = 0;
	MetaScreen* _tmp3_;
	GList* workspaces = NULL;
	MetaScreen* _tmp4_;
	GList* _tmp5_;
	GList* _tmp6_;
	g_return_if_fail (self != NULL);
	if (!meta_prefs_get_dynamic_workspaces ()) {
		return;
	}
	_tmp0_ = self->priv->_wm;
	_tmp1_ = meta_plugin_get_screen ((MetaPlugin*) _tmp0_);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	screen = _tmp2_;
	_tmp3_ = screen;
	last_index = meta_screen_get_n_workspaces (_tmp3_) - 1;
	_tmp4_ = screen;
	_tmp5_ = meta_screen_get_workspaces (_tmp4_);
	workspaces = _tmp5_;
	_tmp6_ = workspaces;
	{
		GList* workspace_collection = NULL;
		GList* workspace_it = NULL;
		workspace_collection = _tmp6_;
		for (workspace_it = workspace_collection; workspace_it != NULL; workspace_it = workspace_it->next) {
			MetaWorkspace* _tmp7_;
			MetaWorkspace* workspace = NULL;
			_tmp7_ = _g_object_ref0 ((MetaWorkspace*) workspace_it->data);
			workspace = _tmp7_;
			{
				gboolean _tmp8_ = FALSE;
				MetaWorkspace* _tmp9_;
				_tmp9_ = workspace;
				if (gala_utils_get_n_windows (_tmp9_) < ((guint) 1)) {
					MetaWorkspace* _tmp10_;
					_tmp10_ = workspace;
					_tmp8_ = meta_workspace_index (_tmp10_) != last_index;
				} else {
					_tmp8_ = FALSE;
				}
				if (_tmp8_) {
					MetaWorkspace* _tmp11_;
					_tmp11_ = workspace;
					gala_workspace_manager_remove_workspace (self, _tmp11_);
				}
				_g_object_unref0 (workspace);
			}
		}
	}
	_g_object_unref0 (screen);
}

GalaWindowManager*
gala_workspace_manager_get_wm (GalaWorkspaceManager* self)
{
	GalaWindowManager* result;
	GalaWindowManager* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_wm;
	result = _tmp0_;
	return result;
}

static void
gala_workspace_manager_set_wm (GalaWorkspaceManager* self,
                               GalaWindowManager* value)
{
	g_return_if_fail (self != NULL);
	if (gala_workspace_manager_get_wm (self) != value) {
		GalaWindowManager* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_wm);
		self->priv->_wm = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gala_workspace_manager_properties[GALA_WORKSPACE_MANAGER_WM_PROPERTY]);
	}
}

static GObject *
gala_workspace_manager_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaWorkspaceManager * self;
	GeeLinkedList* _tmp0_;
	MetaScreen* screen = NULL;
	GalaWindowManager* _tmp1_;
	MetaScreen* _tmp2_;
	MetaScreen* _tmp8_;
	MetaScreen* _tmp9_;
	MetaScreen* _tmp10_;
	MetaScreen* _tmp11_;
	MetaScreen* _tmp12_;
	gboolean _tmp13_ = FALSE;
	parent_class = G_OBJECT_CLASS (gala_workspace_manager_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManager);
	_tmp0_ = gee_linked_list_new (meta_workspace_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->workspaces_marked_removed);
	self->priv->workspaces_marked_removed = _tmp0_;
	_tmp1_ = self->priv->_wm;
	_tmp2_ = meta_plugin_get_screen ((MetaPlugin*) _tmp1_);
	screen = _tmp2_;
	if (meta_prefs_get_dynamic_workspaces ()) {
		MetaScreen* _tmp3_;
		_tmp3_ = screen;
		meta_screen_override_workspace_layout (_tmp3_, META_SCREEN_TOPLEFT, FALSE, 1, -1);
	}
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp4_ = FALSE;
			_tmp4_ = TRUE;
			while (TRUE) {
				MetaScreen* _tmp6_;
				MetaScreen* _tmp7_;
				if (!_tmp4_) {
					gint _tmp5_;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp4_ = FALSE;
				_tmp6_ = screen;
				if (!(i < meta_screen_get_n_workspaces (_tmp6_))) {
					break;
				}
				_tmp7_ = screen;
				gala_workspace_manager_workspace_added (self, _tmp7_, i);
			}
		}
	}
	meta_prefs_add_listener (_gala_workspace_manager_prefs_listener_meta_prefs_changed_func, self);
	_tmp8_ = screen;
	g_signal_connect_object (_tmp8_, "workspace-switched", (GCallback) _gala_workspace_manager_workspace_switched_meta_screen_workspace_switched, self, G_CONNECT_AFTER);
	_tmp9_ = screen;
	g_signal_connect_object (_tmp9_, "workspace-added", (GCallback) _gala_workspace_manager_workspace_added_meta_screen_workspace_added, self, 0);
	_tmp10_ = screen;
	g_signal_connect_object (_tmp10_, "workspace-removed", (GCallback) _gala_workspace_manager_workspace_removed_meta_screen_workspace_removed, self, G_CONNECT_AFTER);
	_tmp11_ = screen;
	g_signal_connect_object (_tmp11_, "window-entered-monitor", (GCallback) _gala_workspace_manager_window_entered_monitor_meta_screen_window_entered_monitor, self, 0);
	_tmp12_ = screen;
	g_signal_connect_object (_tmp12_, "window-left-monitor", (GCallback) _gala_workspace_manager_window_left_monitor_meta_screen_window_left_monitor, self, 0);
	if (meta_prefs_get_dynamic_workspaces ()) {
		MetaScreen* _tmp14_;
		MetaScreen* _tmp15_;
		MetaWorkspace* _tmp16_;
		_tmp14_ = screen;
		_tmp15_ = screen;
		_tmp16_ = meta_screen_get_workspace_by_index (_tmp14_, meta_screen_get_n_workspaces (_tmp15_) - 1);
		_tmp13_ = gala_utils_get_n_windows (_tmp16_) > ((guint) 0);
	} else {
		_tmp13_ = FALSE;
	}
	if (_tmp13_) {
		gala_workspace_manager_append_workspace (self);
	}
	gala_workspace_manager_cleanup (self);
	return obj;
}

static void
gala_workspace_manager_class_init (GalaWorkspaceManagerClass * klass,
                                   gpointer klass_data)
{
	gala_workspace_manager_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &GalaWorkspaceManager_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_workspace_manager_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_workspace_manager_set_property;
	G_OBJECT_CLASS (klass)->constructor = gala_workspace_manager_constructor;
	G_OBJECT_CLASS (klass)->finalize = gala_workspace_manager_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WORKSPACE_MANAGER_WM_PROPERTY, gala_workspace_manager_properties[GALA_WORKSPACE_MANAGER_WM_PROPERTY] = g_param_spec_object ("wm", "wm", "wm", GALA_TYPE_WINDOW_MANAGER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}

static void
gala_workspace_manager_instance_init (GalaWorkspaceManager * self,
                                      gpointer klass)
{
	self->priv = gala_workspace_manager_get_instance_private (self);
	self->priv->remove_freeze_count = 0;
}

static void
gala_workspace_manager_finalize (GObject * obj)
{
	GalaWorkspaceManager * self;
	MetaScreen* screen = NULL;
	GalaWindowManager* _tmp0_;
	MetaScreen* _tmp1_;
	MetaScreen* _tmp2_;
	guint _tmp3_;
	MetaScreen* _tmp4_;
	guint _tmp5_;
	MetaScreen* _tmp6_;
	guint _tmp7_;
	MetaScreen* _tmp8_;
	guint _tmp9_;
	MetaScreen* _tmp10_;
	guint _tmp11_;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManager);
	meta_prefs_remove_listener (_gala_workspace_manager_prefs_listener_meta_prefs_changed_func, self);
	_tmp0_ = self->priv->_wm;
	_tmp1_ = meta_plugin_get_screen ((MetaPlugin*) _tmp0_);
	screen = _tmp1_;
	_tmp2_ = screen;
	g_signal_parse_name ("workspace-added", meta_screen_get_type (), &_tmp3_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _gala_workspace_manager_workspace_added_meta_screen_workspace_added, self);
	_tmp4_ = screen;
	g_signal_parse_name ("workspace-switched", meta_screen_get_type (), &_tmp5_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _gala_workspace_manager_workspace_switched_meta_screen_workspace_switched, self);
	_tmp6_ = screen;
	g_signal_parse_name ("workspace-removed", meta_screen_get_type (), &_tmp7_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _gala_workspace_manager_workspace_removed_meta_screen_workspace_removed, self);
	_tmp8_ = screen;
	g_signal_parse_name ("window-entered-monitor", meta_screen_get_type (), &_tmp9_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _gala_workspace_manager_window_entered_monitor_meta_screen_window_entered_monitor, self);
	_tmp10_ = screen;
	g_signal_parse_name ("window-left-monitor", meta_screen_get_type (), &_tmp11_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp10_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp11_, 0, NULL, (GCallback) _gala_workspace_manager_window_left_monitor_meta_screen_window_left_monitor, self);
	_g_object_unref0 (self->priv->_wm);
	_g_object_unref0 (self->priv->workspaces_marked_removed);
	G_OBJECT_CLASS (gala_workspace_manager_parent_class)->finalize (obj);
}

GType
gala_workspace_manager_get_type (void)
{
	static volatile gsize gala_workspace_manager_type_id__volatile = 0;
	if (g_once_init_enter (&gala_workspace_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GalaWorkspaceManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_workspace_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaWorkspaceManager), 0, (GInstanceInitFunc) gala_workspace_manager_instance_init, NULL };
		GType gala_workspace_manager_type_id;
		gala_workspace_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "GalaWorkspaceManager", &g_define_type_info, 0);
		GalaWorkspaceManager_private_offset = g_type_add_instance_private (gala_workspace_manager_type_id, sizeof (GalaWorkspaceManagerPrivate));
		g_once_init_leave (&gala_workspace_manager_type_id__volatile, gala_workspace_manager_type_id);
	}
	return gala_workspace_manager_type_id__volatile;
}

static void
_vala_gala_workspace_manager_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	GalaWorkspaceManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManager);
	switch (property_id) {
		case GALA_WORKSPACE_MANAGER_WM_PROPERTY:
		g_value_set_object (value, gala_workspace_manager_get_wm (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_gala_workspace_manager_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	GalaWorkspaceManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManager);
	switch (property_id) {
		case GALA_WORKSPACE_MANAGER_WM_PROPERTY:
		gala_workspace_manager_set_wm (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

